(*^

::[paletteColors = 128; 
	fontset = title, "New York", 24, L3, center, bold, nohscroll;
	fontset = subtitle, "New York", 18, L2, center, bold, nohscroll;
	fontset = subsubtitle, "New York", 14, L2, center, bold, nohscroll;
	fontset = section, "New York", 14, L2, bold, nohscroll, grayBox;
	fontset = subsection, "New York", 12, L2, bold, nohscroll, blackBox;
	fontset = subsubsection, "New York", 10, L2, bold, nohscroll, whiteBox;
	fontset = text, "New York", 12, L2, nohscroll;
	fontset = smalltext, "New York", 10, L2, nohscroll;
	fontset = input, "Courier", 10, L2, nowordwrap;
	fontset = output, "Courier", 12, L2, nowordwrap;
	fontset = message, "Courier", 12, L2, R65535, nowordwrap;
	fontset = print, "Courier", 12, L2, nowordwrap;
	fontset = info, "Courier", 12, L2, nowordwrap;
	fontset = postscript, "Courier", 12, L2, nowordwrap;
	fontset = name, "Geneva", 10, L2, italic, B65535, nowordwrap, nohscroll;
	fontset = header, "Times", 10, L2;
	fontset = footer, "Times", 12, L2, center;
	fontset = help, "Geneva", 10, L2, nohscroll;
	fontset = clipboard, "New York", 12, L2;
	fontset = completions, "New York", 12, L2, nowordwrap;
	fontset = network, "Courier", 10, L2, nowordwrap;
	fontset = graphlabel, "Courier", 12, L2, nowordwrap;
	fontset = special1, "New York", 12, L2, nowordwrap;
	fontset = special2, "New York", 12, L2, center, nowordwrap;
	fontset = special3, "New York", 12, L2, right, nowordwrap;
	fontset = special4, "New York", 12, L2, nowordwrap;
	fontset = special5, "New York", 12, L2, nowordwrap;]
:[font = input; initialization; ]
*)
SemCirc[knot_,point_]:=
Block[ {G,H,r,circ,dist},
         
         dist=point-knot;
         r=dist/2;
         G[x_]:=(-1)*Sqrt[(2*r-x+knot) (x-knot)];
         H[i_]:={knot+((i-1)/16)*(dist),G[knot+((i-1)/16)*(dist)]};
         circ=Array[H,17];
         Return[circ]
       ]
       
Connections[knot_,point_,height_]:=
Block[ {semi,flip,raise},
        
        semi=SemCirc[knot,point];
        flip=Map[#*{1,-1}&,semi];
        raise=Reverse[Map[#+{0,height}&,flip]];
        Return[Flatten[{semi,raise},1]]
     ]
     
Corridor[width_,num_]:=
Block[ {R},

        R[i_]:=(width+1)+i*(2/num)-(1/num);
        Return[Reverse[Array[R,num]]]
       ]
       
Connect[height_,width_]:= (*assume origbr, origword- global*)
Block[ {num,flatword,flatbr,points,colors,F,thick},
        
        If[origword=={},Return[{}]];
        flatword=Flatten[origword];
        flatbr=Flatten[origbr];
        num=Length[flatword];
        thick=Thickness[.01];
        points=Corridor[width,num];
        colors=Map[Flatten[Position[origword,#],1][[1]]&, flatword];
        F[i_]:=
        Block[ {pos,knot,point},
                
                knot=flatword[[i]];
                pos=Flatten[Position[flatbr,knot]];
                point=points[[pos[[1]]]];
                Return[{thick,kcolor[colors[[i]]],
                         Line[Connections[knot,point,height]]}]
               ];
       Return[Array[F,num]]
     ]
                
(*
^*)