(*^

::[paletteColors = 128; 
	fontset = title, "New York", 24, L3, center, bold, nohscroll;
	fontset = subtitle, "New York", 18, L2, center, bold, nohscroll;
	fontset = subsubtitle, "New York", 14, L2, center, bold, nohscroll;
	fontset = section, "New York", 14, L2, bold, nohscroll, grayBox;
	fontset = subsection, "New York", 12, L2, bold, nohscroll, blackBox;
	fontset = subsubsection, "New York", 10, L2, bold, nohscroll, whiteBox;
	fontset = text, "New York", 12, L2, nohscroll;
	fontset = smalltext, "New York", 10, L2, nohscroll;
	fontset = input, "Courier", 10, L2, nowordwrap;
	fontset = output, "Courier", 12, L2, nowordwrap;
	fontset = message, "Courier", 12, L2, R65535, nowordwrap;
	fontset = print, "Courier", 12, L2, nowordwrap;
	fontset = info, "Courier", 12, L2, nowordwrap;
	fontset = postscript, "Courier", 12, L2, nowordwrap;
	fontset = name, "Geneva", 10, L2, italic, B65535, nowordwrap, nohscroll;
	fontset = header, "Times", 10, L2;
	fontset = footer, "Times", 12, L2, center;
	fontset = help, "Geneva", 10, L2, nohscroll;
	fontset = clipboard, "New York", 12, L2;
	fontset = completions, "New York", 12, L2, nowordwrap;
	fontset = network, "Courier", 10, L2, nowordwrap;
	fontset = graphlabel, "Courier", 12, L2, nowordwrap;
	fontset = special1, "New York", 12, L2, nowordwrap;
	fontset = special2, "New York", 12, L2, center, nowordwrap;
	fontset = special3, "New York", 12, L2, right, nowordwrap;
	fontset = special4, "New York", 12, L2, nowordwrap;
	fontset = special5, "New York", 12, L2, nowordwrap;]
:[font = input; initialization; ]
*)
kcolor[3]:= RGBColor[0.990, 1.000, 0.602];(*yellow*)
kcolor[2]:= RGBColor[0.578, 1.000, 0.622];(*light green*)
kcolor[6]:= RGBColor[0.641, 1.000, 0.923];(*very light blue*)
kcolor[1]:=RGBColor[0.658, 0.703, 1.000];(*light blue*)
kcolor[7]:= RGBColor[0.967, 0.718, 1.000];(*light pink*)
kcolor[8]:= RGBColor[1.000, 0.662, 0.516];(*light brownish*)
kcolor[10]:= RGBColor[0.426, 0.603, 1.000];(*darker blue*)
kcolor[4]:= RGBColor[0.684, 1.000, 0.350];(*green*)
kcolor[9]:= RGBColor[1.000, 0.468, 0.833];(*pink*)
kcolor[5]:= RGBColor[0.619, 0.449, 1.000];(*purple*)
(*
:[font = input; initialization; ]
*)
Knit[br_,kind_,level_]:=Knit[br,kind,level,False]
(*
:[font = input; initialization; ]
*)
Perbr[i_]:=perbranch[[branches[[i]]]]
(*
:[font = input; initialization; ]
*)
Knit[br_,kind_,level_,crosscheck_]:=
Block[ {kfrom,kto,i,j,len,lines={},
        width,relbr,temp,crossbr=0},
        
        If[origword=={},Return[{}]];
        kfrom=Perbr[br];
        Which[kind==rcross,crossbr=br,
              kind==lcross,crossbr=br-1];
        If[kfrom=={},
            If[crosscheck,PermBr[crossbr]
              ];Return[{}]
           ];
        width=Thickness[.01];
        len=Length[kfrom];
        relbr=branches[[br]];
        Which[kind==inj,
             temp=listRepl[inj,relbr];kto=temp[[relbr]],
             True,
             perbranch=listRepl[kind,relbr];kto=Perbr[br]
          ]; 
        tie[i_]:=
              {kcolor[GetColor[br,i]],
              Line[cosline[kto[[i]],kfrom[[i]],level]]};
       lines=Array[tie,len];
       PrependTo[lines,width];
       If[crosscheck,PermBr[crossbr]];
       Return[Flatten[lines]]
    ]
(*
:[font = input; initialization; ]
*)
Knotting[wd_List,branch_]:=  
Block[ {prepared,period,orgwd,
        perbr={},temp={},
        i,j,k,num,len,many,divs},
        
       period=Apply[LCM,Map[Length,wd]]; 
       orgwd=Prepare[wd,period];
       prepared=Sort[Flatten[orgwd]];
       j=0;
       num=branch^(period-1);
       findivs[e_]:=Quotient[e,num]==j;
       For[i=1,i<=branch,i++,
           AppendTo[temp,Select[prepared, findivs]];
           j++
          ];
       len=Length[temp];
      For[i=1,i<=len,i++,
          many=Length[temp[[i]]];
          divs=BrDivisions[many,i];
          AppendTo[perbr,divs];
          For[k=1,k<=many,k++,
             orgwd=orgwd/. temp[[i,k]]->divs[[k]];
             ]
         ];
      Return[{orgwd,perbr}]
     ]
       
       
(*
:[font = input; initialization; ]
*)
Pairity[branch_]:=
Which[Mod[torsion[[branch]],2]==0,1,
                            True,-1]
                            
InduceOrder[wd_List,b_]:= (*takes word and creates new word*) 
Block[ {wdmap={},wdadd,   (*according to kneading sequence*)
        i,j,len,partsum},
        
        If[Depth[wd]>2,Return[Map[InduceOrder,wd]]];
        wdadd=wd+1;
        len=Length[wdadd];
        For[i=1,i<=len,i++,
            partsum=Product[Pairity[wdadd[[j]]],{j,i-1}];
            AppendTo[wdmap, 
               Which[partsum>=0, wdadd[[i]],
                     True, (b+1)-(wdadd[[i]])]]
             ];
         Return[wdmap-1]
     ]
     
NaryTrans[wd_List,b_]:= (*translates N-ary sequence into decimel*)
Block[ {i,len},
        
        If[Depth[wd]>2,Return[Map[NaryTrans,wd]]];
        len=Length[wd];
        Return[Sum[wd[[i]]*b^(len-i),{i,len}]]
     ]
(*
:[font = input; initialization; ]
*)
ExtendWd[wd_List,lcm_]:=
Block[ {i,expwd={}},
        
        For[i=1,i<=Length[wd],i++,
            AppendTo[expwd,Flatten[Table[wd[[i]],
                           {lcm/Length[wd[[i]]]}]]]
           ];
        Return[expwd]
      ]
(*
:[font = input; initialization; ]
*)
 ExtendWd[wd_]:=ExtendWd[wd,period]; 
 InduceOrder[wd_]:=InduceOrder[wd,branch];
 NaryTrans[wd_]:=NaryTrans[wd,branch];
(*
:[font = input; initialization; ]
*)
Prepare[wd_List,lcm_]:=  (*takes original list*) 
Block[ {wdperm,wdext,wdind,wdtrans,period},
        
        period=lcm;
        wdperm=Map[Cyc,wd];
        wdext=Map[ExtendWd,wdperm];
        wdind=Map[InduceOrder,wdext];
        wdtrans=Map[NaryTrans,wdind];
        Return[wdtrans]
      ]

Cyc[wd_]:=NestList[RotateLeft,wd,Length[wd]-1]


(*
:[font = input; initialization; ]
*)
listRepl[kind_,br_]:=
Block[ {lc,rc},
      lc[x_]:=x-2;
      rc[x_]:=x+2;
      Which[kind==twist,  MapAt[Reverse,perbranch,{{br}}],
            kind==rcross, MapAt[rc,perbranch,{{br}}],
            kind==lcross, MapAt[lc,perbranch,{{br}}],
            kind==inj,    MapAt[injmap,perbranch,{{br}}],
            kind==extend, perbranch
            ]
       ]

        

(*
:[font = input; initialization; ]
*)
injmap[wd_List]:=Map[GetInj,wd]
(*
:[font = input; initialization; ]
*)
BrDivisions[manybr_,whatbr_]:=    (*takes list of int. per branch and*)
Block[ {len,i,offset,             (*# of branch and returns coords. Assumes*)
       num,coords={}},            (*list in order*)
       
       If[manybr==0,Return[{}]];                           
       num=branchnum[whatbr];
       offset=1/(2*manybr);                          
       div[j_]:=(j/manybr)-offset+num;
       Return[Array[div,manybr]]
    ]
(*
:[font = input; initialization; ]
*)
GetInj[a_]:=
Block[ {pos,camefrom,wdpos,mapto},

        pos=Flatten[Position[perbranch,a]];
        camefrom=origbr[[pos[[1]],pos[[2]]]];
        wdpos=Flatten[Position[origword,camefrom]];
        mapto=Map[RotateLeft,origword][[wdpos[[1]],wdpos[[2]]]];
        Return[mapto]
      ]      
(*
:[font = input; initialization; ]
*)
GetColor[br_,i_]:=
Block[ {pos,place},

       pos=origbr[[branches[[br]],i]];
       place=Flatten[Position[origword,pos]][[1]];
       Return[place]
     ]
(*
:[font = input; initialization; ]
*)
PermCl[a_]:=
Block[ {temp},

       temp=cl[[a+1]];
       cl[[a+1]]=cl[[a]];
       cl[[a]]=temp
     ]
(*
:[font = input; initialization; ]
*)
PermBr[a_]:=
Block[ {temp},

       temp=branches[[a+1]];
       branches[[a+1]]=branches[[a]];
       branches[[a]]=temp
     ]
(*
:[font = input; initialization; ]
*)
PermPerBr[a_]:=
Block[ {temp},

       temp=perbranch[[a+1]];
       perbranch[[a+1]]=perbranch[[a]];
       perbranch[[a]]=temp
     ]
(*
^*)