/*	Standard Dialog Utilities
 *	Requires myString.c--sEquate() routine
 */

#include "DialogUtils.h"
#include "GeneralUtils.h"

Point	StdFilePoint = {50,78};
			/*	Normally, CommandKeyFilter will, if there's no EditText,
			 *	interpret single character typed as if one had pressed
			 *	command, for radio buttons and check boxes.
			 *	If CheckCharIfNoCommand FALSE, it will not do this.
			 *	Motivation was Open dialog, in which single
			 *	chars typed should be interpreted as letters of
			 *	filenames; in Bouncing Ball, I had added a check box which
			 *	"stole" the letter 'g'.
			 *		-TA 1/21/91
			 */
Boolean	CheckCharIfNoCommand = TRUE;
Boolean	(*CKF_Filter)() = NIL;

OutlineButton(DialogPtr dp,int  itemNo)
{
	int			itemType;
	Handle		item;
	Rect		box;
	GrafPtr		thePort;
	PenState	thePS;

	GetPort(&thePort); SetPort(dp);	GetPenState(&thePS);
	GetDItem(dp, itemNo, &itemType, &item, &box);
	InsetRect(&box,-4,-4);		PenSize(3,3);
	FrameRoundRect(&box,16,16);	PenSize(thePS.pnSize.h, thePS.pnSize.v);
	SetPort(thePort);
}

pascal void OutlineRoutine(WindowPtr wp, int itemNo)
{
	int			itemType;
	Handle		item;
	Rect		box;
	PenState	thePS;

	GetPenState(&thePS);
	GetDItem((DialogPtr) wp, 1, &itemType, &item, &box);
	InsetRect(&box,-4,-4);		PenSize(3,3);
	FrameRoundRect(&box,16,16);	PenSize(thePS.pnSize.h, thePS.pnSize.v);
}

MakeUserItemOutline(DialogPtr dp, int itemNo)
{
	int		itemType;
	Handle	item;
	Rect	box;

	GetDItem(dp, itemNo, &itemType, &item, &box);
	SetDItem(dp, itemNo, itemType, (Handle) &OutlineRoutine, &box);
}

char GetOtherKeyboardChar(char c)
{
	if (islower(c)) return(toupper(c));
	if (isupper(c)) return(tolower(c));

	switch (c) {
		case '0':	return(')');
		case '1':	return('!');
		case '2':	return('@');
		case '3':	return('#');
		case '4':	return('$');
		case '5':	return('%');
		case '6':	return('^');
		case '7':	return('&');
		case '8':	return('*');
		case '9':	return('(');

		case ')':	return('0');
		case '!':	return('1');
		case '@':	return('2');
		case '#':	return('3');
		case '$':	return('4');
		case '%':	return('5');
		case '^':	return('6');
		case '&':	return('7');
		case '*':	return('8');
		case '(':	return('9');

		case '-':	return('_');
		case '=':	return('+');
		case '[':	return('{');
		case ']':	return('}');
		case ';':	return(':');
		case '\'':	return('"');
		case ',':	return('<');
		case '.':	return('>');
		case '/':	return('?');
		case '`':	return('~');
		case '\\':	return('|');

		case '_':	return('-');
		case '+':	return('=');
		case '{':	return('[');
		case '}':	return(']');
		case ':':	return(';');
		case '"':	return('\'');
		case '<':	return(',');
		case '>':	return('.');
		case '?':	return('/');
		case '~':	return('`');
		case '|':	return('\\');

		default:	return('\0');
	}
}

Boolean ActiveDlogControl(WindowPtr wp, Handle item, int itemType,
			Rect *pbox, char *ps)
{
	Rect			dummyRect;
	ControlHandle	ch;

	if (itemType & itemDisable) return(FALSE);
	ch = (ControlHandle) item;
	if ( (unsigned char) (**ch).contrlHilite >= 254) return(FALSE);
	if (!(**ch).contrlVis) return(FALSE);
	if ( !SectRect(&(wp->portRect), pbox, &dummyRect) ) return(FALSE);
	GetCTitle(ch, ps);
	return(TRUE);
}

SetCheckCharIfNoCommand(Boolean TurnItOn)
{
	CheckCharIfNoCommand = TurnItOn;
}

SetCKF_Filter(Boolean (*EventFilterProc)())
{
	CKF_Filter = EventFilterProc;
}

ClickButton(ControlHandle ch)
{
	HiliteControl(ch, 1);
	HiliteControl(ch, 0);
}

pascal Boolean CommandKeyFilter(DialogPtr dp, EventRecord *theEvent, int *itemHit)
{
	DialogPeek	dpk = (DialogPeek) dp;
	Boolean		CommandKey;
	char		theChar, theOtherChar;
	int 		itemNo, itemType;
	Handle		item;
	Rect		box;
	Str255		s;
	TEHandle	teh;
	Boolean		HowCKFShouldReturn;
	Boolean		WasEscape = FALSE;

	if (CKF_Filter != NIL)
		if ( (*CKF_Filter)(dp, theEvent, itemHit, &HowCKFShouldReturn) )
			return(HowCKFShouldReturn);

	switch ((*theEvent).what) {
		case keyDown: 
		case autoKey:
			theChar = BitAnd((*theEvent).message, charCodeMask);
			if (theChar == '\t') {
				if ( ((*theEvent).modifiers & shiftKey) == 0 )
					return(FALSE);
		    	if (dpk->editField == NO_EDIT_TEXT)
		    		return(FALSE);
		    	itemNo = dpk->editField + 1;
		    	while (TRUE) {
		    		--itemNo;
		    		if (itemNo <= 0)	break;
					GetDItem(dp, itemNo, &itemType, &item, &box);
					if (itemType == editText) {
						mySelItemText(dp, itemNo);
						*itemHit = itemNo;
						return(TRUE);
					}
				}
	    		for(itemNo=dpk->editField+1; ;++itemNo) {
					itemType = -1;
					GetDItem(dp, itemNo, &itemType, &item, &box);
					if (itemType == -1) break;
				}
		    	while (TRUE) {
		    		--itemNo;
		    		if (itemNo <= dpk->editField)
		    			return(FALSE);	/*	Should not get here	*/
					GetDItem(dp, itemNo, &itemType, &item, &box);
					if (itemType == editText) {
						mySelItemText(dp, itemNo);
						*itemHit = itemNo;
						return(TRUE);
					}
				}
			}
			if ( (theChar == '\r') || (theChar == '\3') ) {
				GetDItem(dp, 1, &itemType, &item, &box);
				if (itemType == ctrlItem+btnCtrl)
					if ( ActiveDlogControl((WindowPtr) dp, item, itemType,
							&box, (char *) s) ) {
						*itemHit = 1;
						ClickButton((ControlHandle) item);
						return(TRUE);
					}
			}
			CommandKey = ((*theEvent).modifiers & cmdKey) != 0;
			if (theChar == ESCAPE) {
				theChar = DOT;
				CommandKey = TRUE;
				WasEscape = TRUE;
			}
		    if (!CommandKey)
		    	if ( (dpk->editField != NO_EDIT_TEXT) ||
		    			(!CheckCharIfNoCommand) )
		    		return(FALSE);
	    	if ( (theChar == DOT) && CommandKey ) {
	    								/*	1.	Look for Cancel	*/
	    		for(itemNo=1; ;++itemNo) {
					itemType = -1;
					GetDItem(dp, itemNo, &itemType, &item, &box);
					if (itemType == -1) break;
					if (itemType != ctrlItem+btnCtrl) continue;
					if ( !ActiveDlogControl((WindowPtr) dp, item, itemType,
							&box, (char *) s) ) continue;
					if (sUpperComp((char *) s,"\PCANCEL") == 0) {
						*itemHit = itemNo;
						ClickButton((ControlHandle) item);
						return(TRUE);
					}
				}
	    								/*	2.	Look for No	*/
	    		for(itemNo=1; ;++itemNo) {
					itemType = -1;
					GetDItem(dp, itemNo, &itemType, &item, &box);
					if (itemType == -1) break;
					if (itemType != ctrlItem+btnCtrl) continue;
					if ( !ActiveDlogControl((WindowPtr) dp, item, itemType,
							&box, (char *) s) ) continue;
					if (sUpperComp((char *) s,"\PNO") == 0) {
						*itemHit = itemNo;
						ClickButton((ControlHandle) item);
						return(TRUE);
					}
				}
	    								/*	3.	Hit item 2, as long as active
	    								 *		button, and not Yes or OK
	    								 */
	    		for(itemNo=2; itemNo<=2; ++itemNo) {
					itemType = -1;
					GetDItem(dp, itemNo, &itemType, &item, &box);
					if (itemType == -1)							break;
					if (itemType != ctrlItem+btnCtrl)			break;
					if ( !ActiveDlogControl((WindowPtr) dp,
							item, itemType, &box, (char *) s) )	break;
					if (sUpperComp((char *) s,"\POK") == 0)		break;
					if (sUpperComp((char *) s,"\PYES") == 0)	break;

					*itemHit = itemNo;		/*	2default command-.	*/
					ClickButton((ControlHandle) item);
					return(TRUE);
				}
				if (WasEscape)
					return(FALSE);
			}
			theOtherChar = GetOtherKeyboardChar(theChar);
			for(itemNo=1;;++itemNo) {
				itemType = -1;
				GetDItem(dp, itemNo, &itemType, &item, &box);
				if (itemType == -1) break;
				if (!(itemType & ctrlItem)) continue;
				if ( (!CommandKey) && (itemType == ctrlItem+btnCtrl) )
					continue;	/*	Only do buttons if command key pressed */
				if ( !ActiveDlogControl((WindowPtr) dp, item, itemType,
						&box, (char *) s) ) continue;
				if ( (s[1] == theChar) || (s[1] == theOtherChar) ) {
					*itemHit = itemNo;
					if (itemType == ctrlItem+btnCtrl)
						ClickButton((ControlHandle) item);
					return(TRUE);
				}
			}
			if ( CommandKey && (dpk->editField != NO_EDIT_TEXT) )
				switch (theChar) {
					case CUT_CHAR:
					case COPY_CHAR:
								teh = dpk->textH;
								if ( (**teh).selEnd > (**teh).selStart ) {
									if (theChar = CUT_CHAR)			TECut(teh);
									else if (theChar = COPY_CHAR)	TECopy(teh);
									if (ZeroScrap() == noErr)
										TEToScrap();
								}
								*itemHit = dpk->editField+1;
								return(TRUE);
					case PASTE_CHAR:
								TEFromScrap();
								TEPaste(dpk->textH);
								*itemHit = dpk->editField+1;
								return(TRUE);
				}

			(*theEvent).what = nullEvent;
/*
			(*theEvent).what = mouseDown;
			(*theEvent).where.h = (*theEvent).where.v = 0;
*/
			return(FALSE); /* if command, but no button */
			break;
		default:
			;
	}

	return(FALSE);
}

int	HandleDialog(dp, SelectItemNo, StopItem, OutlineItem,
		EventFilterProc, ItemFilterProc, CloseRoutine)
	DialogPtr	dp;
	int			SelectItemNo, StopItem, OutlineItem;
	Boolean		(*EventFilterProc)(), (*ItemFilterProc)(), (*CloseRoutine)();
	/*		In general, should handle buttons, check boxes, radio buttons,
	 *  and edit text items, most notably with the exception of inter-
	 *  relating (usu. mutually exclusive) radio buttons.
	 *		Pass -1 (NO_SELECT_ITEM) for SelectItemNo if no edit text items
	 *	are to be initially selected.
	 *		Pass the number of the last item which should stop the dialog
	 *	in StopItem.  Many dialogs are of the form OK item is #1,
	 *	Cancel item is #2; for these, pass 2 as StopItem.
	 *		Also in general, the dialog box should outline the default item
	 *	(which, barring an overriding filterproc, will be item 1).  Pass 1
	 *	in the OutlineItem argument to outline this button, pass the
	 *	number of a userItem if you want to use that instead (then it will
	 *	update properly), and pass 0 if you do not want to outline any
	 *	item.
	 *		EventFilterProc is a ProcPtr to a C routine which takes
	 *	as arguments the DialogPtr, a pointer to the EventRecord,
	 *	a pointer to the int itemHit, and a pointer to a Boolean
	 *	value which CommandKeyFilter should return (if CommandKeyFilter
	 *	should do no processing; see below).
	 *	It is called from within the default CommandKeyFilter,
	 *	which basically filters command key events for controls
	 *	whose titles begin with the letter pressed.
	 *	It should return FALSE if CommandKeyFilter should still
	 *	process the event in the usual way, TRUE if CommandKeyFilter
	 *	should return (return value determined by last argument).
	 *	For example, an EventFilterProc which just returned TRUE, with
	 *	last argument set to FALSE, would effectively enable a bypass
	 *	of CommandKeyFilter.
	 *	Pass NIL in this field to have CommandKeyFilter do no
	 *	extra filtering.
	 *		ItemFilterProc is a ProcPtr to a C routine which takes
	 *	as arguments the DialogPtr and the item number, and returns Boolean.
	 *	It can be used to perform some additional action in
	 *	response to a button or edit text item etc.
	 *	It should return FALSE if HandleDialog should still process the
	 *	item in the usual way, TRUE if HandleDialog should ignore it.
	 *	Pass NIL in this field to have HandleDialog ignore this argument.
	 *		CloseRoutine is a ProcPtr to a C routine which takes
	 *	as arguments the DialogPtr and the number of the item hit
	 *	to close the dialog box, and returns Boolean.
	 *	It can be used to determine if it is OK to close a dialog box.
	 *	For example, it could check that "legal" data has been entered,
	 *	say, numeric values in numeric text edit fields.
	 *	It should return TRUE if it is OK to close the dialog box,
	 *	FALSE if it is not.
	 *	Pass NIL in this field to have HandleDialog ignore this argument.
	 *		The function returns the number of the dialog item which stopped
	 *	the dialog (in the example above, 1 if OK, 2 if Cancel).
	 */
{
	int		itemHit;
	int 	itemNo, itemType, otherItemType;
	Handle	item, otherItem;
	Rect	box, otherBox;
	Boolean	GroupedRadioButtons;
	int		i;

	SetPort(dp);

	if (SelectItemNo != NO_SELECT_ITEM)
		mySelItemText(dp, SelectItemNo);

	ShowWindow(dp);
	if (OutlineItem == 1)
		OutlineButton(dp, 1);
	else if (OutlineItem > 1)
		MakeUserItemOutline(dp, OutlineItem);
	SetCKF_Filter(EventFilterProc);

	while (TRUE) {
		ModalDialog(&CommandKeyFilter, &itemHit);
		if (ItemFilterProc != NIL)
			if ( (*ItemFilterProc)(dp, itemHit) )
				continue;
		GetDItem(dp, itemHit, &itemType, &item, &box);
		switch (itemType) {
			case (ctrlItem + chkCtrl):
				SetCtlValue(item, (int) (GetCtlValue(item) == 0) );
				break;
			case (ctrlItem + radCtrl):
				GroupedRadioButtons = FALSE;
				for(i=itemHit-1; i>0; --i) {
					GetDItem(dp, i, &otherItemType, &otherItem, &otherBox);
					if (otherItemType == ctrlItem + radCtrl) {
						GroupedRadioButtons = TRUE;
						SetCtlValue(otherItem, 0);
					}
					else break;
				}
				for(i=itemHit+1; i<= *( (int *) (*(*((DialogPeek) dp)).items))+1; ++i) {
					GetDItem(dp, i, &otherItemType, &otherItem, &otherBox);
					if (otherItemType == ctrlItem + radCtrl) {
						GroupedRadioButtons = TRUE;
						SetCtlValue(otherItem, 0);
					}
					else break;
				}
				if (GroupedRadioButtons)
					SetCtlValue(item, 1);
				else
					SetCtlValue(item, (int) (GetCtlValue(item) == 0) );
				break;
		}
		if ((itemHit<=StopItem) && (itemHit>=0)) {
			if (CloseRoutine != NIL)
				if ( !(*CloseRoutine)(dp, itemHit) )
					continue;
			break;
		}
	}
	HideWindow(dp);
	SetCKF_Filter(NIL);
	return(itemHit);
}

mySelItemText(DialogPtr dp, int itemNo)
	/* Selects all text in item itemNo */
{
	SelIText(dp, itemNo, 0, MAX_ITEM_CHARS);
}

mySetItemText(DialogPtr dp, int itemNo, char *ps)
	/* Sets text in item itemNo to s */
{
	int	itemType;	Handle item;	Rect box;

	GetDItem(dp, itemNo, &itemType, &item, &box);
	if ( (itemType == statText) || (itemType == editText) )
		SetIText(item, ps);
	else if (itemType & ctrlItem)
		SetCTitle((ControlHandle) item, ps);
}

myGetItemText(DialogPtr dp, int itemNo, char *ps)
	/* Puts text from item itemNo into s */
{
	int	itemType;	Handle item;	Rect box;

	GetDItem(dp, itemNo, &itemType, &item, &box);
	if ( (itemType == statText) || (itemType == editText) )
		GetIText(item, ps);
	else if (itemType & ctrlItem)
		GetCTitle((ControlHandle) item, ps);
}

mySetItemLong(DialogPtr dp,int itemNo,long l)
	/* Sets text in item itemNo to long l */
{
	Str255 s;	char *ps = (char *) &s;

	NumToString(l, ps);
	mySetItemText(dp, itemNo, ps);
}

Boolean myGetItemLong(DialogPtr dp, int itemNo, long *pl)
	/* Returns long from item itemNo */
{
	Str255 s;	char *ps = (char *) &s;

	myGetItemText(dp, itemNo, ps);
	return( myStringToLong(ps, pl) );
}

mySetItemFloat(DialogPtr dp, int itemNo, double f, int prec)
	/* Sets text in item itemNo to double f */
{
	Str255 s;	char *ps = (char *) &s;

	myFToStrNoPad(f, ps, 0, prec);
	mySetItemText(dp, itemNo, ps);
}

Boolean	myGetItemFloat(DialogPtr dp, int itemNo, double *pf)
	/* Returns double from item itemNo */
{
	Str255 s;	char *ps = (char *) &s;

	myGetItemText(dp, itemNo, ps);
	return( strToF(ps, pf) );
}

mySetItemCtlValue(dp, itemNo, theValue)
	DialogPtr dp;
	int itemNo, theValue;
	/* Sets dialog control itemNo to value theValue */
{
	int	itemType;	Handle item;	Rect box;

	GetDItem(dp, itemNo, &itemType, &item, &box);
	SetCtlValue(item, theValue);
}

int	myGetItemCtlValue(DialogPtr dp,int  itemNo)
	/* Gets value of control itemNo */
{
	int	itemType;	Handle item;	Rect box;

	GetDItem(dp, itemNo, &itemType, &item, &box);
	return(GetCtlValue(item));
}

myDisableCtlItem(DialogPtr dp,int  itemNo)
	/* Disables control itemNo */
{
	int	itemType;	Handle item;	Rect box;

	GetDItem(dp, itemNo, &itemType, &item, &box);
	HiliteControl(item, 255);
	/* no need to disable the item for the dialog?-could add 128 to itemType */
}

myEnableCtlItem(DialogPtr dp,int  itemNo)
	/* Enables control itemNo */
{
	int	itemType;	Handle item;	Rect box;

	GetDItem(dp, itemNo, &itemType, &item, &box);
	HiliteControl(item, 0);
	/* no need to enable the item for the dialog?-could add 128 to itemType */
}

Boolean SimpleOpenDialog(OSType OpenFileType, int *vRef, char *fname)
{
	SFReply		mySFReply;
	SFTypeList	mySFTypeList;

	mySFTypeList[0] = OpenFileType;
	SFPGetFile(StdFilePoint, "\P", 0L,1, &mySFTypeList, 0L, &mySFReply,
			getDlgID, &CommandKeyFilter);
	if (!mySFReply.good)
		return(FALSE);
	*vRef = mySFReply.vRefNum;
	sEquate(fname, (char *) &mySFReply.fName);
	return(TRUE);
}

Boolean SimpleSaveAsDialog(char *prompt, int *vRef, char *fname)
{
	SFReply	mySFReply;

	SFPPutFile(StdFilePoint, prompt, fname, 0L, &mySFReply,
			putDlgID, &CommandKeyFilter);
	if (!mySFReply.good)
		return(FALSE);
	*vRef = mySFReply.vRefNum;
	sEquate(fname, (char *) &mySFReply.fName);
	return(TRUE);
}

int AddDItem(int DLogID, Boolean FirstOne, int itemType, Rect *pItemRect, char *title)
	/*	Adds dialog item to resource item list (type 'DITL').
	 *	Must be called *before* GetNewDialog...
	 */
{
	DialogTHndl	dth;
	int			i;
	Rect		ItemRect;
	long		ItemSize;
	Handle		h;

	if (pItemRect == 0L)	SetRect(&ItemRect, 0, 0, 0, 0);
	else					ItemRect = *pItemRect;

	if ((dth = (DialogTHndl) GetResource('DLOG', DLogID)) == 0L)
		return(0);
	if (FirstOne)	h = GetFreshResource('DITL', (**dth).itemsID);
	else			h = GetResource('DITL', (**dth).itemsID);
	HNoPurge(h);
	ItemSize = GetHandleSize(h);
	SetHandleSize(h, ItemSize + 14L + title[0] + (title[0]%2) );
	HLock(h);
	++( *( (int *) *h));
	( *( (int *) (*h + ItemSize+0))) = 0;
	( *( (int *) (*h + ItemSize+2))) = 0;
	( *( (int *) (*h + ItemSize+4))) = ItemRect.top;
	( *( (int *) (*h + ItemSize+6))) = ItemRect.left;
	( *( (int *) (*h + ItemSize+8))) = ItemRect.bottom;
	( *( (int *) (*h + ItemSize+10))) = ItemRect.right;
	*(*h + ItemSize+12) = itemType;
	*(*h + ItemSize+13) = title[0];
	for (i=1; i<=title[0]; ++i)
		*(*h + ItemSize+13+i) = title[i];
	HUnlock(h);
	return( *( (int *) *h) + 1);
}

int AddDResItem(int DLogID, Boolean FirstOne, int itemType, Rect *pItemRect, int resID)
	/*	Adds dialog item to resource item list (type 'DITL').
	 *	Must be called *before* GetNewDialog...
	 */
{
	DialogTHndl	dth;
	int			i;
	Rect		ItemRect;
	long		ItemSize;
	Handle		h;

	if (pItemRect == 0L)	SetRect(&ItemRect, 0, 0, 0, 0);
	else					ItemRect = *pItemRect;

	if ((dth = (DialogTHndl) GetResource('DLOG', DLogID)) == 0L)
		return(0);
	if (FirstOne)	h = GetFreshResource('DITL', (**dth).itemsID);
	else			h = GetResource('DITL', (**dth).itemsID);
	HNoPurge(h);
	ItemSize = GetHandleSize(h);
	SetHandleSize(h, ItemSize + 14L + 2L );
	HLock(h);
	++( *( (int *) *h));
	( *( (int *) (*h + ItemSize+0))) = 0;
	( *( (int *) (*h + ItemSize+2))) = 0;
	( *( (int *) (*h + ItemSize+4))) = ItemRect.top;
	( *( (int *) (*h + ItemSize+6))) = ItemRect.left;
	( *( (int *) (*h + ItemSize+8))) = ItemRect.bottom;
	( *( (int *) (*h + ItemSize+10))) = ItemRect.right;
	*(*h + ItemSize+12) = itemType;
	*(*h + ItemSize+13) = 2;
	*( (int *) (*h + ItemSize+14) ) = resID;
	HUnlock(h);
	return( *( (int *) *h) + 1);
}

ReleaseDialogResources(DialogTHndl dth)
{
	Handle		h;

	h = GetResource('DITL', (**dth).itemsID);
	ReleaseResource(h);
	ReleaseResource((Handle) dth);
}
