/*
 *	FileUtils.c
 *
 *	General file utilities.
 *
 *	-TA 6/27/90
 */

#ifndef	_FileUtils_
#define _FileUtils_

#include <GeneralUtils.h>
#include <StringUtils.h>

#define	FileAlertID			300
#define	VolumeAlertID		301
#define	AlertOSType			'ALRT'
#define	FErrOSType			'FERR'
#define	PICT_OSType			'PICT'

#define BufSize				1024L
#define HalfBufSize			512L	/* BufSize >> 1 */
#define WriteBufSize		512L

#define	NoAppFile			-1

#define	SPACE				' '
#define	RETURN_CHAR			'\r'
#define	OPTION_SPACE		''
#define	FORCED_SPACE			0x01
#define	MAX_POINTER_SIZE	32768L

typedef	struct	{
	char	half1[HalfBufSize], half2[HalfBufSize];
}	Buffers;

typedef union	{
	char	whole[BufSize];
	Buffers	halves;
}	FileBuffer;

	int		GetOpenRefNum(void);
	int		GetSaveRefNum(void);
	Boolean	GoodVolumeOp(int myErrNo, char *myActionString);
	Boolean	StoreDefaultVolume(void);
	Boolean	RestoreDefaultVolume(void);
	Boolean	SetDefaultVolume(int vRef);
	Boolean	GoodFileOp(int myErrNo, char *myActionString, char *myFName);
	int		SimpleGetParamFile(OSType GoodFType, int *pVRef, char *fname);
	Boolean	SetFileCreatorAndType(char *fname, int theVRef,
				OSType Creator, OSType Type);
	Boolean	StdCreateFile(char *fname, int vref, OSType Creator,
				OSType Type);
	Boolean	StartFileRead(int theVRef, char *fname, Boolean OKToFail);
			ResetFileRead(void);
			StopFileRead(void);
	Boolean	CheckNextRead(void);
	Boolean	ReadTextFileLine(char *theLine);
	Boolean	ReadPackedRow(char **pdstPtr, int rowBytes);
	Boolean ReadPtrFromFile(Ptr thePtr, long *pReadAmt);
	Boolean	ReadHandleFromFile(Handle theHandle, long *pReadAmt);
	Boolean	ReadPICT(PicHandle *ppic);
	Boolean	StartFileSave(char *fname, int theVRef);
	Boolean	StopFileSave(void);
	Boolean	DeleteSaveFile(void);
	Boolean	WritePtrToFile(Ptr thePtr, long TotalAmt);
	Boolean	WriteHandleToFile(Handle theHandle, long TotalAmt);
	Boolean	WriteTEtoFile(TEHandle WriteTE, long WriteStart);
	Boolean	WritePICTToFile(PicHandle pic);
	Boolean	Delim_WritePtrToFile(Ptr thePtr, long WriteAmt,
				char *DelimString, int MinSpaces, int *NumSpaces,
				Boolean SubstOptSpace, Boolean UseForcedSpace);
	Boolean	Delim_WriteHandleToFile(Handle theHandle, long WriteAmt,
				char *DelimString, int MinSpaces, int *NumSpaces,
				Boolean SubstOptSpace, Boolean UseForcedSpace);
	Boolean	Delim_WriteTEtoFile(TEHandle WriteTE, long WriteStart,
				char *DelimString, int MinSpaces, int *NumSpaces,
				Boolean SubstOptSpace, Boolean UseForcedSpace);
	Boolean	OpenBitMap(BitMap *pbm);
	Boolean	SaveBitMap(BitMap *pbm);
	Boolean	OpenResFork(char *fname, int vRef, Boolean ForceResFork,
				Boolean *Exists);
	Boolean	StopResFile(void);
	Boolean	Delete1Resource(ResType theType, int theID, Boolean *pWasThere);
	Boolean	AddNewResource(Handle h, ResType theType, int theID);
	Boolean	UpdateResFork(void);
	Boolean	StdPutPicture(PicHandle pic, int theID);

#endif	_FileUtils_
