/*
 *	GraphUtils.c
 *
 *	Standard graphics routines for handling Mac User Interface and other
 *
 *	-TA 6/24/90
 */

#include "GraphUtils.h"

long PtSqrDist(Point p1, Point p2)
{
	return( ((long) (p1.h-p2.h))*(p1.h-p2.h) +
			((long) (p1.v-p2.v))*(p1.v-p2.v) );
}

myCopyBits(Port1,Port2, r, h1,v1,h2,v2, theMode, maskRgn)
	GrafPtr		Port1,Port2;
	Rect		*r;
	int			h1,v1,h2,v2;
	int			theMode;
	RgnHandle	maskRgn;
{
	Rect	r1, r2;

	r1 = *r;	OffsetRect(&r1, h1, v1);
	r2 = *r;	OffsetRect(&r2, h2, v2);
	CopyBits(&(Port1->portBits), &(Port2->portBits), &r1, &r2, theMode, maskRgn);
}

DrawJustString(int just, char *ps)
{
	switch(just) {
		case teJustRight:	Move(-StringWidth(ps), 0);			break;
		case teJustCenter:	Move(-(StringWidth(ps)-1)/2, 0);	break;
								/*	-1 for pixel after character	*/
		case teJustLeft:
		default:												break;
	}
	DrawString(ps);
}

DrawFloat(double f, int fw, int prec, Boolean Pad)
{
	Str255	sf;
	char	*psf = (char *) &sf;

	PadFtoStr(f, psf, fw, prec, Pad);
	DrawString(psf);
}

StdForceUpdate(WindowPtr wp)
{
	SetPort(wp);
	InvalRect(&wp->portRect);
}

NoClippingRect(WindowPtr wp)
{
	SetPort(wp);
	ClipRect(&wp->portRect);
}

GetStdDocWindowClipRect(Rect *pr, WindowPtr wp)
{
	*pr = wp->portRect;
	(*pr).right -= ScrollBarWidth-1; (*pr).bottom -= ScrollBarWidth-1;
}

StdDocWindowClipRect(WindowPtr wp)
{
	Rect	tmpRect;

	GetStdDocWindowClipRect(&tmpRect, wp);
	SetPort(wp);
	ClipRect(&tmpRect);
}

EraseGrowIcon(WindowPtr wp)
{
	Rect	GrowIconRect;
	GrafPtr	thePort;

	GetPort(&thePort);
	SetRect(&GrowIconRect,0,0,15,15);
	OffsetRect(&GrowIconRect, wp->portRect.right-15,wp->portRect.bottom-15);
	SetPort(wp); EraseRect(&GrowIconRect);
	SetPort(thePort);
}

StdGoAwayWindow(Point pt, WindowPtr WhichWindow)
{
	if (TrackGoAway(WhichWindow, pt/*.vh*/)) HideWindow(WhichWindow);
}

StdZoomWindow(WindowPtr WhichWindow, int Part, Boolean BringToFront)
{
	SetPort(WhichWindow);
	ZoomWindow(WhichWindow, Part, BringToFront);
}

StdHandleActivate(WindowPtr wp, int ActivateFlag)
{
	Rect	tmpRect;

	if (!(ActivateFlag & 1))
		EraseGrowIcon(wp);
	tmpRect = wp->portRect;
	SetPort(wp); ClipRect(&tmpRect);
	DrawGrowIcon(wp);
	StdDocWindowClipRect(wp);
}
