/*	MenuUtils.c
 *
 *	Library for standard menu-handling calls.
 *	First created for Bouncing Ball, 7/90
 *
 *	-TA
 */

#include "MenuUtils.h"

Boolean StdAddMenu(int menuid, MenuHandle *pmh)
{
	*pmh = GetMenu(menuid);
	if (*pmh == 0L)
		return(FALSE);
	InsertMenu(*pmh, 0);
	return(TRUE);
}

HandleDeskAcc(MenuHandle TheAppleMenuH, int TheAppleMenuID, int menuItem)
/*	Can pass *either* MenuHandle or MenuIDMenuHandle overrides, pass
 *	(MenuHandle) 0L for MenuHandle if to use MenuID
 */
{
	GrafPtr		savePort;
	Str255		s;

	GetPort(&savePort);
	if (TheAppleMenuH==0L)
		TheAppleMenuH = GetMHandle(TheAppleMenuID);
	GetItem(TheAppleMenuH, menuItem, (char *) s);
	OpenDeskAcc((char *) s);
	SetPort(savePort);
}

HandleSysEdit(int menuItem)
{
	if (!SystemEdit(menuItem-1))
	  SysBeep(5);
}

int IsCommandKey(long EventMessage, int Modifiers)
{
	if (!(Modifiers & cmdKey)) return(0);
	return(LoWord(EventMessage & charCodeMask));
}

ToggleItemEnabled(MenuHandle menu, int item, Boolean EnableIt)
{
	if (EnableIt)	EnableItem(menu, item);
	else			DisableItem(menu, item);
}

Boolean TestItemEnabled(MenuHandle menu, int item)
{
	Boolean	TestResult;

	if (item >= 32)
		return(TRUE);
	HLock((Handle) menu);
	TestResult = BitTst((Ptr) &((**menu).enableFlags), (long) 31-item);
	HUnlock((Handle) menu);
	return(TestResult);
}

AdjustOnlySysEditMenu(MenuHandle menuH)
{
	register	WindowPeek	wp = (WindowPeek) FrontWindow();
				Boolean		DA = IS_SYS_WINDOW(wp);
	
	ToggleItemEnabled(menuH, 1, DA);
	ToggleItemEnabled(menuH, 3, DA);
	ToggleItemEnabled(menuH, 4, DA);
	ToggleItemEnabled(menuH, 5, DA);
	ToggleItemEnabled(menuH, 6, DA);
}
