/*
 *	MusicUtils.c
 *
 *	Music library created first for Bouncing Ball sounds.
 *	All calls are built around one octave.
 *	Extracted from Bouncing Ball sound library.
 *		-Tyler Abbott, 7/90
 */

#include "MusicUtils.h"

int		Chromatics[12];

InitOctave(int BaseTone)
{
	int		i;

	Chromatics[0] = BaseTone;
	for(i=1; i<ChromaticTones; ++i)
		Chromatics[i] = RoundToInt(Chromatics[0]*
				pow(2,i/( (double) ChromaticTones ) ));
}

int	MajorIndex(int i)	{	return(i + i - (i+1)/4);	}

int	MinorIndex(int i)	{	return(i + i - (i+1)/3);	}

int	GetMajorTone(double FreqRatio)
{
	int		index;

	index = (int) ((double) DiatonicTones*FreqRatio);
	if (index == DiatonicTones) --index;
	return(Chromatics[MajorIndex(index)]);
}

int	GetMinorTone(double FreqRatio)
{
	int		index;

	index = (int) ((double) DiatonicTones*FreqRatio);
	if (index == DiatonicTones) --index;
	return(Chromatics[MinorIndex(index)]);
}

int	GetChromaticTone(double FreqRatio)
{
	int		index;

	index = (int) ((double) ChromaticTones*FreqRatio);
	if (index == ChromaticTones) --index;
	return(Chromatics[index]);
}

int	GetContinuousTone(int BaseTone, double FreqRatio)
{
	return(RoundToInt(BaseTone + FreqRatio*BaseTone));
}

int	GetContinuousLogTone(int BaseTone, double FreqRatio)
{
	return( RoundToInt(BaseTone * pow(2.0,FreqRatio)) );
}
