/*	OffPort.h
 *	Library for creating Off-Screen GrafPorts
 *	(mainly Off-Screen Bitmaps)
 *	Based on standard Rascal library
 *	Transcribed by Tyler Abbott, 12/89
 */

#include "OffPort.h"

GrafPtr NewOffPort(Rect *R)
{
	GrafPtr	ThePort,CurPort;
	BitMap	TheMap;
	long	BitSize;
	long	RowBytes;
	char	*Bits;

	GetPort(&CurPort);

	RowBytes = (R->right - R->left /*+7?*/ )/8 + 1 /*not +1*/ ;
	if (RowBytes & 1) ++RowBytes; 
	BitSize = RowBytes*(R->bottom-R->top);

	Bits = NewPtr(BitSize);
	if (!Bits)	return(0L);

	ThePort = (GrafPtr) NewPtr((long) (sizeof(GrafPort)));
	if (!ThePort) {
		DisposPtr(Bits);
		return(0L);
	}

	TheMap.bounds = *R;
	TheMap.rowBytes = RowBytes;
	TheMap.baseAddr = Bits;

	OpenPort(ThePort);
	PortSize(R->right-R->left,R->bottom-R->top);
	SetPortBits(&TheMap);

	RectRgn(ThePort->visRgn,&ThePort->portRect);
	EraseRect(&ThePort->portRect);
	ClipRect(&ThePort->portRect);
	SetPort(CurPort);
	return(ThePort);
}

DisposeOffPort(GrafPtr WhichPort)
{
  ClosePort(WhichPort);
  DisposPtr(WhichPort->portBits.baseAddr);
  DisposPtr(WhichPort);
};

CGrafPtr NewCOffPort(Rect *R, int depth)
/*	Doesn't Work yet, ran out of time to debug
 *		-TA 1/15/91
 */
{
	GrafPtr		CurPort;
	CGrafPtr	ThePort;
	long		BitSize;
	long		RowBytes;
	char		*Bits;
	GDHandle	gdh;

	gdh = GetGDevice();
	GetPort(&CurPort);

	RowBytes = ( (R->right-R->left+1)*depth + 7)/8;
	if (RowBytes & 1) ++RowBytes; 
	BitSize = RowBytes*(R->bottom-R->top);

	Bits = NewPtr(BitSize);
	if (!Bits)	return(0L);

	ThePort = (CGrafPtr) NewPtr((long) (sizeof(CGrafPort)));
	if (!ThePort) {
		DisposPtr(Bits);
		return(0L);
	}

	SetGDevice(GetMainDevice());
	OpenCPort(ThePort);
	SetGDevice(gdh);
	(**ThePort->portPixMap).baseAddr = Bits;
	(**ThePort->portPixMap).rowBytes = RowBytes;
	(**ThePort->portPixMap).bounds = *R;
	(**ThePort->portPixMap).pixelSize = depth;

	PortSize(R->right-R->left,R->bottom-R->top);
/*
	SetPortBits(&TheMap);
*/

	RectRgn(ThePort->visRgn,&ThePort->portRect);
	EraseRect(&ThePort->portRect);
	ClipRect(&ThePort->portRect);
	SetPort(CurPort);
	return(ThePort);
}

DisposeCOffPort(CGrafPtr WhichPort)
{
  CloseCPort(WhichPort);
  DisposPtr((**WhichPort->portPixMap).baseAddr);
  DisposPtr(WhichPort);
};
