/*
 *	bbGraphics.h
 *
 *	Constants etc. for graphics files
 *
 *		-TA 11/8/90
 */

#define	NOPORT				( (GrafPtr) -1L )
#define	w					(*pw)

#define	LWR_MARGIN			3
#define	LWR_TOP				(MBarHeight+MBarHeight+1)
#define	StdMargin			4
#define	TextHeight			9	/* Used mainly with Impact Map window */
#define	TextLineHeight		(TextHeight+2)
#define	Traj_LeftMargin		15
#define	Traj_TopMargin		(StdMargin+TextLineHeight)
#define	Traj_RightMargin	28	/* ScrollBarWidth + 2, + 10 for axis label */
#define	Traj_BottomMargin	36	/* ScrollBarWidth + room for writing v0, delta */
#define	IM_TopMargin		(StdMargin + TextHeight/2)
#define	BottomTextMargin	2
#define	HashSize			4
#define	TextMargin			4
#define	BodyTETop			46
#define	TS_BodyTETop		(BodyTETop+TextLineHeight)
#define	TxOutFieldWidth		8
#define	TxOutPrecision		(TxOutFieldWidth-1)
#define	TxOutWholePlaces	2
#define	PS_precision		4
#define	MANY_IMPACTS		256
#define	BALL_DIAMETER		20
#define	TABLE_WIDTH			100
#define	TABLE_HEIGHT		10
#define	FRAME_DIST			16
#define	PERMA_TABLE_H		(BALL_DIAMETER+4)
#define	PERMA_FRAME_H		(PERMA_TABLE_H+TABLE_WIDTH+4)
#define	PS_LeftMargin		(StdMargin + StringWidth("\P-0.00")/2)
#define	PS_TopMargin		(StdMargin + TextHeight + 2)
#define	PS_RightMargin		(ScrollBarWidth+StdMargin+StringWidth("\P0.00")/2)
#define	PS_BottomMargin		(ScrollBarWidth+TextHeight+TextHeight)
#define	HorAxisLabelHOffset	5
#define	VerAxisLabelVOffset	3

#define	StdIMFieldWidth			5
#define	IMPrecDiff				2
#define	ImpactRightMargin		(StdMargin + StringWidth("\P0.00")/2)
#define	ImpactLeftMargin		(StdMargin + 71)

#define	MAX_HotSpots			2	/*	NO_HotSpot defined in bb.h	*/

#define	RelPlaces				2	/*	Relative decimal places/mag.	*/
#define	MagnifyingGlassCursorID	130
#define	NumDashedLinePatterns	12
#define	AnimationPatsID			132

enum	{	BallPattern = 0, TablePattern, FramePattern, NumAnimationPats };

typedef struct {
	WindowPeek		Peek;
	GrafPtr			Back;				/*	Background Offport */
	double			xScale, yScale;
	DoubleRect		GraphRange;			/*	Only used if Magnifying	*/
	Rect			GR, PR;				/*	"GraphRect", "PinRect" */
	Rect			BackLimits;			/*	BackPort drawing limits,
										 *	for non-scalable windows */
	Point			Origin, BackOrigin;
	ControlHandle	RSB, BSB;			/*	Right/Bottom Scroll Bar	*/
	ControlHandle	HS[MAX_HotSpots];	/*	"Hot Spots"	*/
	Boolean			DrawFromScratch, Magnifying;
	Boolean			xGraphAroundZero, yGraphAroundZero;
	Boolean			WindowCleared;
	Boolean			ReservedBoolean;
	long			Reserved1, Reserved2, Reserved3, Reserved4;
}		BBWindow;
typedef	BBWindow	Windows[NumWindows];
