/*	bbIteration.h
 *
 *	Definitions, Types to iterate different sets of vars
 *	(normal, bifurcation diagram, basin of attraction)
 *
 *		-TA 2/11/91
 */


typedef struct {
			double	_v0, _delta;		/* Initial Conditions */
			double	_A, _freq, _damp;	/* Physical System Parameters */
			double	_Period, _Omega;	/* Calculated from freq */
						/* Above global; below mostly for bbIteration	*/
			int		_HitNumber, _HitInd1, _HitInd2, _RealHitNumber;
			double	_HitTime;
			int		_StuckStatus, _NewStuckStatus;
			double	_ti, _xi, _vi;
			double	_tj, _xj, _vj;
			double	_phase, _t, _tau;
			double	_ElapsedTime;
			double	_dt, _ndt, _tdt;		/* dt, Nick's dt, Tyler's dt */
			double	_tstop;
			double	_ti_Continuing;		/* For Continue Iteration */
			int		_StuckCount;
		}	IterationVars, *pIterationVars;

#define	v0				(pCurrentVars->_v0)
#define	delta			(pCurrentVars->_delta)
#define	A				(pCurrentVars->_A)
#define	freq			(pCurrentVars->_freq)
#define	damp			(pCurrentVars->_damp)
#define	Period			(pCurrentVars->_Period)
#define	Omega			(pCurrentVars->_Omega)
#define	HitNumber		(pCurrentVars->_HitNumber)
#define	HitInd1			(pCurrentVars->_HitInd1)
#define	HitInd2			(pCurrentVars->_HitInd2)
#define	RealHitNumber	(pCurrentVars->_RealHitNumber)
#define	HitTime			(pCurrentVars->_HitTime)
#define	StuckStatus		(pCurrentVars->_StuckStatus)
#define	NewStuckStatus	(pCurrentVars->_NewStuckStatus)
#define	ti				(pCurrentVars->_ti)
#define	xi				(pCurrentVars->_xi)
#define	vi				(pCurrentVars->_vi)
#define	tj				(pCurrentVars->_tj)
#define	xj				(pCurrentVars->_xj)
#define	vj				(pCurrentVars->_vj)
#define	phase			(pCurrentVars->_phase)
#define	t				(pCurrentVars->_t)
#define	tau				(pCurrentVars->_tau)
#define	ElapsedTime		(pCurrentVars->_ElapsedTime)
#define	dt				(pCurrentVars->_dt)
#define	ndt				(pCurrentVars->_ndt)
#define	tdt				(pCurrentVars->_tdt)
#define	tstop			(pCurrentVars->_tstop)
#define	ti_Continuing	(pCurrentVars->_ti_Continuing)
#define	StuckCount		(pCurrentVars->_StuckCount)
