/*	bbMenus.h
 *
 *	Menu constants for Bouncing Ball
 *
 *	-TA 7/21/90
 */

enum {								/*	Menu IDs	*/
		AppleMenuID = 1,
		FileMenuID,
		EditMenuID,
		ControlMenuID,
		ParametersMenuID,
		ViewMenuID,
		SpecialMenuID,
		SimpleSoundMenuID,
		WindowsMenuID,
		AdvancedSoundMenuID
};

enum {								/*	File menu options	*/
		NewItem = 1,
		OpenItem,
		SaveItem = OpenItem + 2,
		SaveAsItem,
		SaveDefaultsItem = SaveAsItem + 2,
		PageSetupItem = SaveDefaultsItem + 2,
		PrintItem,
		QuitItem = PrintItem + 2
};

enum {								/*	Edit menu options	*/
		UndoItem = 1,
		CutItem = UndoItem + 2,
		CopyItem,
		PasteItem,
		ClearItem,
		SuppressSaveItem = ClearItem + 2,
		AutoCommandKeyItem,
		BackgroundOperationItem = AutoCommandKeyItem + 2
};

enum {								/*	Control menu options	*/
		BeginIterationItem = 1,
		StopContinueItem,
		DoOneImpactItem,
		PlaybackItem = DoOneImpactItem + 2,
		InitialConditionsItem = PlaybackItem + 2,
		TableParametersItem,
		GetInitFromLastItem = TableParametersItem + 2,
		IterationItem = GetInitFromLastItem + 2
};

/*
enum {								/*	Parameters menu options	*)
		InitialConditionsItem = 1,
		TableParametersItem,
		GetInitFromLastItem = TableParametersItem + 2,
		IterationItem = GetInitFromLastItem + 2
};
*/

enum {								/*	View menu options	*/
		PhaseRangeItem = 1,
		MaxVelocityItem,
		SimulationSpeedItem,
		TrajectoryScalingItem = SimulationSpeedItem + 2,
		ScrollTrajectoryItem,
		ClearImpactsItem = ScrollTrajectoryItem + 2,
		ShowAllImpactsItem,
		ImpactPhasesOffsetItem,
		MagnifyImpactMapItem,
		MagnifyImpactPhasesItem,
		FasterPhaseSpaceItem = MagnifyImpactPhasesItem + 2,
		ClearPhaseSpaceItem,
		UseTimeSeriesItem = ClearPhaseSpaceItem + 2,
		TimeSeriesItem,
		ClearTimeSeriesItem
};

enum {								/*	Special menu options	*/
		StartBifDiagItem = 1,
		StopContBifDiagItem,
		BifurcationDiagramItem,
		BifDiagPhaseRangeItem,
		ClearBifDiagItem,
		GraphInAllWindowsBDItem,
		UseColorBDItem,
		StartBasinsAttrItem = UseColorBDItem + 2,
		StopContBasinsAttrItem,
		BasinsOfAttractionItem,
		BasinsAttrPhaseRangeItem,
		ClearBasinsAttrItem,
		GraphInAllWindowsBAItem,
		UseColorBAItem,
		PatternsItem = UseColorBAItem + 2,
		ColorsItem,
		PrintPatternListItem
};

enum {								/*	Sound menu options	*/
		PhaseTonesItem = 1,	
		VelocityTonesItem,
		OneOctaveItem = VelocityTonesItem + 2,
		AdvancedOptionsItem = OneOctaveItem,
		ThreeOctavesItem,
		MajorMode = ThreeOctavesItem + 2,	/* This and below used by bbSound as well	*/
		MinorMode,
		ChromaticMode,
		ContinuousMode,
		SimpleOptionsItem = ContinuousMode + 2
};

enum {								/*	Windows menu options	*/
/*
		EnlargeWindowItem = 1,
		ArrangeWindowsItem,
*/
		CloseWindowItem = 1,
		ArrangeWindowsItem,
		DefaultConfigItem,
		WindowSeparatorItem,
		TextWindowMenuItem = WindowSeparatorItem+2	/* this used bbWindows only */
};
