/*	bbPrint.c
 *
 *	Does Bouncing Ball's printing.
 *
 *		-TA 8/30/90
 */

#include <PrintTraps.h>
#include <DialogUtils.h>
#include "bbPrototypes.h"
#include "bbGraphics.h"
#include "bbSpecial.h"

#define	PrintHeaderMargin	3*TextLineHeight
#define	PrintBottomMargin	15

#define	PatternWindex		-2
#define	PatternSize			32
#define	PatternMargin		8
#define	FirstPatTextIndex	9
#define	PatTextFont			systemFont
#define	PatTextSize			12

							/*	from bbGraphics.c		*/
extern	Windows	*pw;
							/*	from bbContGraphics.c	*/
extern	int		AnimaHOffset;
							/*	Global external vars from bb.c	*/
extern	pIterationVars		pCurrentVars;	/*	For HitNumber only	*/
extern	hBBPreferences		hBBPrefs;
							/*	from bbSpecial.c	*/
extern	Pattern				SolutionPats[NumSolutionTypes];


	THPrint		ThePrintHandle = NIL;
	TPPrPort	ThePrintPort;
	TPrStatus	ThePrintStatus;
	GrafPtr		PrintOffPort;		/*	for graphics printing	*/


myPrintIdleProc()
{
	if (!HandlePrintingDialog())
		PrSetError(iPrAbort);
}

InitPrinting()
{
/*
	PrOpen();
	ThePrintHandle = (THPrint) NewHandle(sizeof(TPrint));
	PrintDefault(ThePrintHandle);
*/
}

HaltPrinting()
{
/*
	DisposHandle(ThePrintHandle);
	PrClose();
*/
}

CheckPrintHandle()
{
	if (ThePrintHandle==NIL) {
		ThePrintHandle = (TPrint **) NewHandle( sizeof(TPrint) );
		PrintDefault(ThePrintHandle);
	}

	if(PrValidate(ThePrintHandle))
		;
}

DoPageSetup()
{
	PrOpen();
	CheckPrintHandle();
	if (PrStlDialog(ThePrintHandle))
		;
	PrClose();
}

PrintHeader(int windex, int page)
{
	Str255	s1, s2, p;
	Rect	box = ThePrintPort->gPort.portRect;
	long	secs;
	Boolean	IsTextWindow = (windex==TxOut) || (windex==TSer);

	SetStdTextAttributes();
	if (windex == PatternWindex)
		sEquate((char *) &s1, "\PBouncing Ball Pattern List");
	else {
		switch (windex) {
			case BifD:
			case BAttr:
				GetWTitle((WindowPtr) w[windex].Peek, CP(s1));
				break;
			default:
				GetWTitle((WindowPtr) w[TxOut].Peek, CP(s1));
				if (windex != TxOut) {
					sInsertC(CP(s1), '/', s1[0]+1);
					GetWTitle((WindowPtr) w[windex].Peek, CP(s2));
					sAppend(CP(s1), CP(s2));
				}
				break;
		}
	}
	sInsertC(CP(s1), ReturnChar, s1[0]+1);
	if (ReadDateTime(&secs) == noErr) {
		IUDateString(secs, longDate, CP(s2));
		sAppend(CP(s1), CP(s2));
		sAppend(CP(s1), "\P, ");
		IUTimeString(secs, FALSE, CP(s2));
		sAppend(CP(s1), CP(s2));
		sInsertC(CP(s1), ReturnChar, s1[0]+1);
	}
	if (IsTextWindow) {
		sprintf(CP(p), "Page %d", page);
		CtoPstr(CP(p));
	
		box.right -= (StringWidth(CP(p)) + 1);
	}
	TextBox(CP(s1)+1L, (long) s1[0], &box, teJustLeft);

		/*	Number pages for text printing only	*/
	if (IsTextWindow) {
		box.left = box.right;
		box.right = ThePrintPort->gPort.portRect.right;
		TextBox(CP(p)+1L, (long) p[0], &box, teJustRight);
	}
}

PrintTextWindow(int windex)
{
	TEHandle	hte, bte;
	int			LinesPerPage, FirstLineOnPage=0, CharsToSkip = 0;
	Rect		ViewRect, hViewRect;
	Boolean		BodyExists;
	int			PageNumber = 0;

	HandleAllUpdates();
	StartPrintingDialog();
	PrOpenPage(ThePrintPort, NIL);
	SetPort((GrafPtr) ThePrintPort);
	EraseRect(&ThePrintPort->gPort.portRect);

	hte = GetBBTEHandle(windex, HEADER_TEXT);
	if ( (hte==NIL) || ((**hte).teLength == 0) ) {
		PrClosePage(ThePrintPort);
		return;
	}

	bte = GetBBTEHandle(windex, BODY_TEXT);
	BodyExists = (bte!=NIL) && ((**bte).teLength > 0);

	if (BodyExists) {
		ViewRect = (**bte).viewRect;
		ViewRect.bottom = ((GrafPtr) ThePrintPort)->portRect.bottom;
		ViewRect.bottom -= PrintBottomMargin;
		ViewRect.top += PrintHeaderMargin;
		LinesPerPage = ( ViewRect.bottom - ViewRect.top ) / (**bte).lineHeight;
		ViewRect.bottom = ViewRect.top + (int) (LinesPerPage * (**bte).lineHeight);
		HLock(bte);	HLock((**bte).hText);
	}
	HLock(hte);	HLock((**hte).hText);

	for(;;) {
		myPrintIdleProc();
		SetSameTextAttributes(hte);
		PrintHeader(windex, ++PageNumber);
		hViewRect = (**hte).viewRect;
		OffsetRect(&hViewRect, 0, PrintHeaderMargin);
		TextBox(*(**hte).hText, (long) (**hte).teLength,
				&hViewRect, teJustLeft);
		if (!BodyExists)	{	PrClosePage(ThePrintPort);	break;	}
		SetSameTextAttributes(bte);
		TextBox(*(**bte).hText + CharsToSkip,
			(long) ((**bte).teLength - CharsToSkip), &ViewRect, teJustLeft);
		PrClosePage(ThePrintPort);
		FirstLineOnPage += LinesPerPage;
		if (FirstLineOnPage > (**bte).nLines) break;
		CharsToSkip = (**bte).lineStarts[FirstLineOnPage];
		PrOpenPage(ThePrintPort, NIL);
	}

	HUnlock((**hte).hText);	HUnlock(hte);
	if (!BodyExists)	return;
	HUnlock((**bte).hText);	HUnlock(bte);
}

PrintGraphicsWindow(int windex)
/*	 Copies current window's contents to PrintOffPort,
 *	puts up printing dialog,
 *	prints header,
 *	copies from offport to printport.
 *	 Problem avoiding: copying window's contents with printing dialog
 *	in front, while still having printing dialog come up in a timely
 *	fashion.
 *	Apparently, with QuickDraw printers such as the LaserWriter IISC,
 *	copying the bitmap into the printport actually does the printing,
 *	or the majority of it timewise, so that if we copy directly
 *	into the printport and *then* put up printing dialog,
 *	we don't see the printing dialog until the end, when it just flashes on.
 *		-TA 1/21/91
 */
{
	Rect	tmpRect;

/*	Moved below 11/15/91
	PrOpenPage(ThePrintPort, NIL);
*/
	HandleAllUpdates();

	GetStdDocWindowClipRect(&tmpRect, (WindowPtr) w[windex].Peek);
	SetPort(PrintOffPort);
	ClipRect(&PrintOffPort->portRect);
	EraseRect(&PrintOffPort->portRect);
	MakePicture(windex, PrintOffPort, &tmpRect);

		/* Moved here 11/15/91	*/
	ThePrintPort = PrOpenDoc(ThePrintHandle, NIL, NIL);
	PrOpenPage(ThePrintPort, NIL);

	StartPrintingDialog();
	SetPort((GrafPtr) ThePrintPort);
	EraseRect(&ThePrintPort->gPort.portRect);
	PrintHeader(windex, (**ThePrintHandle).prJob.iFstPage);
	if (windex == Animation)
		SetOrigin(-AnimaHOffset, 0);
	SetOrigin(0, -PrintHeaderMargin);
	if (!SectRect(&tmpRect, &ThePrintPort->gPort.portRect, &tmpRect)) ;
	ClipRect(&tmpRect);
	myCopyBits(PrintOffPort, (GrafPtr) ThePrintPort, &tmpRect,
			0, 0, 0, 0, srcCopy, NIL);
		/*	kludgeyshould call in PrintFrontWindow, but print cancel
		 *	dialog was printing out; this puts it up after printing
		 *	action through.
		 *	If bugs here, try calling whatever is in the switch() in
		 *	HandleUpdate (add a "DrawWindow" to handle this switch()),
		 *	set w[windex].Peek to ThePrintPort (storing real value),
		 *	call DrawWindow, reset w[windex].Peek.
		 *		-TA 12/27/90
		 */
	PrClosePage(ThePrintPort);
}

PrintSpecialWindow(int windex)
{
	Rect	tmpRect;

	PrOpenPage(ThePrintPort, NIL);
	HandleAllUpdates();

/*
	GetStdDocWindowClipRect(&tmpRect, (WindowPtr) w[windex].Peek);
	SetPort(PrintOffPort);
	ClipRect(&PrintOffPort->portRect);
	EraseRect(&PrintOffPort->portRect);
	MakePicture(windex, PrintOffPort, &tmpRect);
*/

	StartPrintingDialog();
	SetPort((GrafPtr) ThePrintPort);
	EraseRect(&ThePrintPort->gPort.portRect);
	PrintHeader(windex, (**ThePrintHandle).prJob.iFstPage);
	SetOrigin(0, -PrintHeaderMargin);
	CopySpecialBackToPrint(windex);
/*
	if (!SectRect(&tmpRect, &ThePrintPort->gPort.portRect, &tmpRect)) ;
	ClipRect(&tmpRect);
*/
/*
	myCopyBits(PrintOffPort, (GrafPtr) ThePrintPort, &tmpRect,
			0, 0, 0, 0, srcCopy, NIL);
*/
	PrClosePage(ThePrintPort);
}

PrintFrontWindow()
{
	WindowPeek	wp = (WindowPeek) FrontWindow();
	int			windex = WindowIndex((WindowPtr) wp);

	if (windex == NoWindow)				return;

	PrOpen();
	CheckPrintHandle();

	if (!PrJobDialog(ThePrintHandle)) {
		PrClose();
		return;
	}

	HandleAllUpdates();
	(**ThePrintHandle).prJob.pIdleProc = &myPrintIdleProc;
/*	Kludge for LaserWriter, 11/15/91. Was putting dialog into window.
	ThePrintPort = PrOpenDoc(ThePrintHandle, NIL, NIL);
*/
/*		kludge--this should really be here.
	StartPrintingDialog();
*/

	switch (windex) {
		case NoWindow:
						PrClose();
						return;
		case TextOutput:
		case TimeSeries:
						ThePrintPort = PrOpenDoc(ThePrintHandle, NIL, NIL);
						PrintTextWindow(windex);
						break;
		case BifDiagram:
		case BasinsAttraction:
						ThePrintPort = PrOpenDoc(ThePrintHandle, NIL, NIL);
						PrintSpecialWindow(windex);
						break;
		default:
						PrintGraphicsWindow(windex);
						break;
	}

	PrCloseDoc(ThePrintPort);
	if ( (**ThePrintHandle).prJob.bJDocLoop != bDraftLoop )
		PrPicFile(ThePrintHandle, NIL, NIL, NIL, &ThePrintStatus);
	StopPrintingDialog();

	PrClose();
}

/*
PrintPatternList()
{
	int			PageNumber = 0, PatternIndex;
	Rect		PatternRect;
	DialogPtr	dp;
	Str255		s;

	if (!PrJobDialog(ThePrintHandle))	return;

	(**ThePrintHandle).prJob.pIdleProc = &myPrintIdleProc;
	ThePrintPort = PrOpenDoc(ThePrintHandle, NIL, NIL);

	PrOpenPage(ThePrintPort, NIL);
	StartPrintingDialog();
	SetPort((GrafPtr) ThePrintPort);
	EraseRect(&ThePrintPort->gPort.portRect);

		SetPort((GrafPtr) ThePrintPort);
		PrintHeader(PatternWindex, ++PageNumber);

		PrClosePage(ThePrintPort);

	PrCloseDoc(ThePrintPort);
	if ( (**ThePrintHandle).prJob.bJDocLoop != bDraftLoop )
		PrPicFile(ThePrintHandle, NIL, NIL, NIL, &ThePrintStatus);

	StopPrintingDialog();
}
*/

PrintPatternList()
{
	int			PageNumber = 0, PatternIndex;
	Rect		PatternRect;
	DialogPtr	dp;
	Str255		s;

	PrOpen();
	CheckPrintHandle();

	if (!PrJobDialog(ThePrintHandle)) {
		PrClose();
		return;
	}

	HandleAllUpdates();
	(**ThePrintHandle).prJob.pIdleProc = &myPrintIdleProc;
	ThePrintPort = PrOpenDoc(ThePrintHandle, NIL, NIL);

	StartPrintingDialog();
	SetPort((GrafPtr) ThePrintPort);
	EraseRect(&ThePrintPort->gPort.portRect);

	dp = GetSolutionInfoDialog();
	PatternIndex = 0;
	SetRect(&PatternRect, 0, 0, PatternSize, PatternSize);

	while(PatternIndex < NumSolutionTypes) {
		PrOpenPage(ThePrintPort, NIL);
		SetPort((GrafPtr) ThePrintPort);
		EraseRect(&ThePrintPort->gPort.portRect);
		PrintHeader(PatternWindex, ++PageNumber);
		SetPort((GrafPtr) ThePrintPort);
		TextFont(PatTextFont);
		TextSize(PatTextSize);
		OffsetRect(&PatternRect, PatternSize, PrintHeaderMargin - PatternSize);

		for(;;) {
			myPrintIdleProc();
			if (PatternIndex >= NumSolutionTypes)
				break;
			OffsetRect(&PatternRect, 0, PatternSize + PatternMargin);
			if (PatternRect.bottom >
					((GrafPtr) ThePrintPort)->portRect.bottom - PrintHeaderMargin) {
				OffsetRect(&PatternRect, -PatternRect.left, -PatternRect.top);
				break;
			}

			FillRect(&PatternRect, &SolutionPats[psi[PatternIndex]]);
			FrameRect(&PatternRect);
			myGetItemText(dp, FirstPatTextIndex + PatternIndex, (char *) &s);
			MoveTo(PatternRect.right + PatternMargin,
				(PatternRect.bottom+PatternRect.top)/2 + PatTextSize/2-1);
			DrawString((char *) &s);
			++PatternIndex;
		}

		PrClosePage(ThePrintPort);
	}

	DisposDialog(dp);
	PrCloseDoc(ThePrintPort);
	if ( (**ThePrintHandle).prJob.bJDocLoop != bDraftLoop )
		PrPicFile(ThePrintHandle, NIL, NIL, NIL, &ThePrintStatus);
	StopPrintingDialog();

	PrClose();
}
