#include <stdio.h>
#include <math.h>

#include <MathUtils.h>
#include <StringUtils.h>
#include <GeneralUtils.h>
#include <GraphUtils.h>
#include <TextUtils.h>
#include "bb.h"
#include "bbPreferences.h"

/*	From bb.c	*/
	Boolean	CheckMem(Size ExtraMemory);
	Boolean	StartingMemCheck(void);
	Boolean	StartIterating(int New_PS);
			StopIterating(Boolean ContinueOK);
			BeginIfAppropriate(void);
	double	GetSolutionInfo(int HitNum, int WhichDouble);
			ResetSolutions(void);
	Boolean	AddSolutionArray(void);
			AddSolution(double del, double v, int StickyState);
			SetDefaultPrefs(void);
			SetDefaults(void);
			SaveDefaults(void);
			SetDefaultParams(void);
			DetermineIfColor(void);
			InitMultiFinderGlobals(void);
			_INIT(void);
			GetInitialFromLast(void);
	Boolean	GetInitialConditions(Boolean DefaultSame);
			SetValuesFromTableParams(double oA, double oFreq, double oDamp);
	Boolean	GetTableParameters(void);
			GetTrajScalingParams(void);
			GetIterationParams(void);
			AdvanceIterationStatus(void);
	Boolean	Handle_ITERATING(int PS);
			Handle_GRAPHING(int PS);
	Boolean	Handle_WRITING(int PS, Boolean *pOKCont);
	Boolean	Handle_META_ITERATING(int PS, Boolean *pOKCont);
			HandleParamFiles(void);
			_MAIN(void);
			HandleContent(WindowPtr wp, Point pt, int mods);
			HandleMouseDown(EventRecord *pev);
			CheckVars_HandleUpdate(WindowPtr wp);
			HandleApp4Event(EventRecord *pEvent);
			_EVENT(EventRecord *theEvent);
	Boolean	NextEvent(int eventMask, EventRecord *theEvent);
			HandleAllActivates(void);
			HandleAllUpdates(void);
			HandleEvent(void);
			main(void);
			_HALT(void);

/*	From bbIteration.c	*/
			SetHitNumber(int NewHitNumber);
	Boolean	HandleSticking(int theEjection);
	Boolean	SetItoJ(Boolean NeedPhase);
			SetInitConditions(void);
	Boolean	InitNextIteration(void);
	Boolean	Initialize_Iteration_Globals(Boolean BeginningIteration,
					Boolean ForceV0);
	Boolean	Reset_Iteration_Globals(void);
	int		IterateSolution(void);
	Boolean	InitPlayback(void);
			GetPlaybackSolution(void);
	Boolean	CheckNextPlayback(void);
			StopOpeningFile(Boolean OpenOK);
	Boolean	GetFileParam(double *pf);
	int		GetFileHeader(void);
	Boolean	StartOpeningFile(void);
	Boolean	GetFloats(char *Line, double *pphase, double *pvel, double *ptime);
	Boolean	CheckForStuckOpen(void);
	int		GetOpenSolution(void);
	Boolean	FinishedOpening(void);
	Boolean	CheckNextOpening(void);
	int		GetNextSolution(int PS);
	Boolean	StartNextSolution(int PS, Boolean *OKCont);
	Boolean	OKtoGraph(int PS);

/*	From bbMenus.c	*/
			QuitPrematurely(void);
			InitBBMenus(Boolean UsingColor);
			AdjustBBMenus(void);
			CheckUseTimeSeries(Boolean theUseTimeSeries);
			ControlMenuStart(int PS);
			ControlMenuStop(int PS, Boolean OKToCont);
			HandleAppleMenu(int menuItem);
	Boolean	DoSave(void);
	Boolean	CheckOneSave(Boolean Quitting, int windex);
	Boolean	CheckNormalSaves(Boolean Quitting);
	Boolean	CheckAllSaves(Boolean Quitting);
			HandleFileMenu(int menuItem);
			HandleEditMenu(int menuItem);
			HandleControlMenu(int menuItem);
			HandleViewMenu(int menuItem);
			HandleSpecialMenu(int menuItem);
			SwitchSoundMenu(void);
			HandleSoundMenu(int menuItem);
			HandleWindowsMenu(int menuItem);
			_MENU(int menuID, int menuItem);
			HandleMenu(long theMenu);
			HandleKeyDown(long EventMessage, int Modifiers);

/*	From bbDialog.c	*/
			SelectBadField(DialogPtr dp, int index, Boolean *PreviousAllRight);
			BadParamAlert(char *s);
			AllBadValsAlert(char *s);
			FixBadValAlert(char *s);
			FixBadIntValAlert(char *s);
			ErrorAlert(char *s1, char *s2, char *s3, char *s4);
			ERROR(char *s);
			DoAboutBBDialog(void);
	Boolean	CheckInitCondDialog(DialogPtr dp, int itemNo);
	Boolean	DoInitCondDialog(double *nV0, double *nDelta, Boolean *myClearSolutions,
				Boolean *RestartIteration);
	Boolean	CheckPhysSysDialog(DialogPtr dp, int itemNo);
	Boolean	DoPhysSysDialog(Boolean *RestartIteration);
			OutOfRangeAlert(char *s, long minL, long maxL);
	Boolean	myGetLongParamItem(DialogPtr dp, int itemNo, long *pl, char *s,
				long minL, long maxL);
	Boolean	CheckTrajScalingDialog(DialogPtr dp, int itemNo);
	Boolean	DoTrajScalingDialog(int *NumPeriods, int *NumAmplitudes);
	Boolean	CheckIterationDialog(DialogPtr dp, int itemNo);
	Boolean	DoIterationDialog(int *pAccuracy, long *pCycles);
			StartStickingMessage(int theStuckCount);
			StopStickingMessage(void);
			SetPhaseString(int Phase, char *PhaseString);
			SetDialogPhases(ControlHandle ch);
	Boolean	PhaseRangeDLogEventFilter(DialogPtr dp, EventRecord *pTheEvent,
				int *pItemHit, Boolean *pHowCKFShouldReturn);
	Boolean	PhaseRangeDLogItemFilter(DialogPtr dp, int itemHit);
	Boolean	DoPhaseRangeDialog(int *pMinPhaseInt, int windex);
	Boolean	SetVMaxDLogItemFilter(DialogPtr dp, int itemHit);
	Boolean	CheckSetVMaxDialog(DialogPtr dp, int itemNo);
	Boolean	DoSetVMaxDialog(double *pVMax, Boolean *pUseAutoVMax);
	Boolean	SimSpeedDLogEventFilter(DialogPtr dp, EventRecord *pTheEvent,
					int *pItemHit, Boolean *pHowCKFShouldReturn);
	Boolean	DoSimulationSpeedDialog(long *pRealPerTicks);
/*
	Boolean	CheckSimulationSpeedDialog(DialogPtr dp, int itemNo);
	Boolean	DoSimulationSpeedDialog(double *pSimSpeed);
*/
	Boolean MagIMapDLogItemFilter(DialogPtr dp, int itemHit);
	Boolean	CheckMagnifyImpactMapDialog(DialogPtr dp, int itemNo);
	Boolean DoMagnifyImpactMapDialog(DoubleRect *Actual, DoubleRect *Full,
				BooleanRect *Used);
	Boolean	CheckMagnifyImpactPhasesDialog(DialogPtr dp, int itemNo);
	Boolean	DoMagnifyImpactPhasesDialog(DoubleRect *Actual, DoubleRect *Full,
				BooleanRect *UsesFull, int IPO);
	Boolean	CheckImpactPhasesOffsetDialog(DialogPtr dp, int itemNo);
	Boolean	DoImpactPhasesOffsetDialog(int *pImpPhsOffset);
	Boolean	CheckTimeSeriesInfoDialog(DialogPtr dp, int itemNo);
	Boolean	DoTimeSeriesInfoDialog(int *pSampleRate,
					Boolean *pUseTimeSeries);
	Boolean	DoStartTimeSeriesDialog(void);
	Boolean	DoStopTimeSeriesDialog(void);
	Boolean	DoShowWindowDialog(int windex);
	Boolean	DoRunInBackgroundDLog(long *pBkgdSleep,
				Boolean *pSuppressBkgdSnd);
			StartPrintingDialog(void);
	Boolean	HandlePrintingDialog(void);
			StopPrintingDialog(void);
	Boolean	DoQuitWarningDialog(Boolean *pWantsToSave, int windex);
	Boolean	DoSaveWarningDialog(Boolean *pWantsToSave, int windex);
	Boolean DoBackgroundDialog(Boolean *pRunInBackground,
					Boolean *pRunQuickly, Boolean *pUseSoundInBG);
	pascal	int		MakeStdFileOutline(int item, DialogPtr StdFileDialog);
	pascal	int		DelimiterDLog(int itemNo, DialogPtr SaveAsDialog);
	Boolean	BBSaveAsDialog(char *prompt, int *vRef, char *fname);
	Boolean	BBSpecialSaveAsDialog(char *prompt, int *vRef, char *fname);
	pascal	int		GWO_Check(int item, DialogPtr OpenDialog);
	Boolean	BBOpenDialog(OSType *OpenFileTypes, int NumOSTypes, int *vRef,
					char *fname, OSType *fType);
	Boolean	BBOpenSpecialDialog(OSType *OpenFileTypes, int NumOSTypes,
					int *vRef, char *fname, OSType *fType);

/*	From bbPhysics.c	*/
			SetTolerance(int theAccuracy);
	double	GetStopTime(long cycles);
			SetFrequencyParams(void);
	double	xTable(double tt);
	double	vTable(double tt);
	double	aTable(double tt);
	double	xBall(double tt, double Xi, double Vi);
	double	vBall(double tt, double Vi);
	double	tFromXTable(double x, Boolean InPrimaryRange);
	double	FindDistance(double Tau, double tt, double Xi, double Vi);
	Boolean	impact(double distance);
	Boolean	FindNStep(double *p_step, double Ti, double Xi, double Vi);
	double	FindTStep(double distance, double Tau, double tt, double Xi,
			double Vi);
	Boolean	root(double *p_TheRoot, double a, double b, double Xi, double Vi,
				double Ti);
	double	SetVj(double Tj, double tt, double Vi);
	int		FindEjection(double *p_ndt, double *p_dt,
				double *p_tj, double *p_xj, double *p_vj);

/*	From bbSound.c	*/
			InitSounds(void);
			FlipTonesOn(int SMenuItem);
			SetNumOctaves(int i);
			SetToneMode(int WhichMode);
	int 	GetTone(double thePhase, double prevHit, double Hit,
				double thePeriod, Boolean Compare);
			MakeTone(double thePhase, double velocity, double prevHit,
				double Hit, double thePeriod, Boolean Compare);

/*	From bbFiles.c	*/
			SetANilFileName(int theWindex);
			SetNilFileNames(void);
	char	*GetSaveFName(int windex);
			SetFileName(int theWindex);
	int		DecideWhichSaveWindow(void);
			InitBBFiles(void);
	int		GetNextParamFile(void);
	int		BBGetParamFiles(void);
	Boolean	BBGetFileLine(char *theLine);
	Boolean	CheckFirstLine(char *theLine);
			CloseOpenFile(void);
	Boolean	GetOpenWindows(void);
	Boolean	OpenFile(void);
			ResetDelimiter(void);
	Boolean	GetOpenFileName(int *pwindex);

/*	2.01 addition
 */
			SetOpenFileName(int windex);
/*	End, 2.01 addition
 */

			ResetFileName(void);
			GetTitleString(int theWindex, char *ts);
	Boolean	CloseSaveFile(Boolean NeedToDelete);
	Boolean	SaveCurWindows(void);
	Boolean	SaveFile(void);
			GetUntitledFileName(char *ps);
			SetGoodSaveFName(Boolean NewGoodSaveFName);
	Boolean	GetGoodSaveFName(void);
	Boolean	SaveAs(void);
	Boolean	SaveFileExists(void);
	Boolean	CreateDefaultsFile(void);
	Boolean	OpenDefaultsFile(void);
			CloseDefaultsFile(void);
	Boolean	OpenDefaults(Boolean *pGotPrefs);
	Boolean	SaveDefaultFile(void);
			HaltBBFiles(void);

/*	From bbPrint.c	*/
			myPrintIdleProc(void);
			InitPrinting(void);
			HaltPrinting(void);
			CheckPrintHandle(void);
			DoPageSetup(void);
			PrintHeader(int windex, int page);
			PrintTextWindow(int windex);
			PrintGraphicsWindow(int windex);
			PrintSpecialWindow(int windex);
			PrintFrontWindow(void);
			PrintPatternList(void);

/*	From bbGraphUtils.c	*/
			WriteVar(char *s, double f);
	Fract	AccurateFracSin(double time);
			InitFixedCoeffs(int YRange);
			SetFixed_G_Over2(double xScale, double yScale);
			InitFixedTraj(double Xi, double Vi, double Ti, int TStart);
	int		xBallFixed(int time);
			InitFixedSineParams(double Ampl, double xScale, double yScale);
	int		xTableFixed(int time);
			SetFixed_G_ps(double xScale, double yScale);
	int		xBallFromV_Fixed(int vint);
			InitPSGraphing(double Xi, double Vi, int yint, double delta_t,
					Boolean *pDrawFromScratch);
			GraphPhaseSpace(int delta_t, int xint, Boolean IsLastPoint);
			InitStuckPhaseSpace(double Ti, double Tj, double thePeriod);
			GraphStuckPhaseSpace(double t_limit, int xint, double Ampl,
					double thePeriod, Boolean LastIteration);
	Boolean	LoadDashedPatterns(void);
	Boolean	TrackDashedRect(int h, int v, Rect *p_DragRect, Rect *p_Outline,
					Boolean ForMagnification);

/*	From bbText.c	*/
				SetTextPorts(GrafPtr gp1, GrafPtr gp2);
	int			GetTextIndex(int windex);
	int			GetWindexFromTindex(int tindex);
	BBTextPtr	GetTextFromTindex(int theTextIndex);
	TEHandle	GetBBTEHandle(int windex, int WhichText);
	Boolean		AnyTSText(void);
				ScrollText(TEHandle teh, int LinesToScroll);
				ScrollWindowText(int windex, int LinesToScroll);
				Scroll_If_Needed(void);
				ScrollBodyTE(void);
				SetNumLines(int windex);
				UpdateText(int windex, double Ampl, double Freq, double Damp);
				HandleTextActivation(int windex, int ActivateFlag);
				ActivateATextScroll(int windex);
				DeactivateATextScroll(int windex);
				ActivateTextScrolls(Boolean Activate_It);
				PtInBodyViewRect(int windex, Point pt);
				HandleTextSelection(int windex, Point pt, int mods);
				HandleTEXTCopy(int windex);
				InitHeaderTE(void);
				InitHeaderTEs(void);
				AppendVar(char *s, double d, TEHandle teh, int WholePlaces);
				AppendVarLn(char *s, double d, TEHandle teh, int WholePlaces);
				SetHeader(int windex, double Ampl, double Freq, double Damp);
				SetHeaders(double Ampl, double Freq, double Damp);
				ResetBodyOFs(void);
				InitBodyOFs(void);
				ClikLoopScroll(TEHandle teh, int LinesToScroll);
	pascal		Boolean	PasClikLoop(void);
				InitBodyTE(int windex);
				InitBodyTEs(void);
	Boolean		CheckBodyTESize(void);
	Boolean		CheckBothBodyTESizes(void);
	Boolean		WriteOutput(int hitnum, double thePhase, double velocity,
					double time, int StickyState, int PS);
	Boolean		WriteTS(double time, double vel, double pos);
				NewTextEdit(void);
				InitTimeSeries(double Ampl, double Freq, double Damp,
						Boolean NeedHeader);
				InitBBTextEdit(double Ampl, double Freq, double Damp);
				DisposeTextEdit(int windex);
				HaltBBTextEdit(void);

/*	From bbControls.c	*/
			SetRScrollBarRect(WindowPtr wp, Rect *pr);
			SetBScrollBarRect(WindowPtr wp, Rect *pr);
			ResizeControl(ControlHandle ch, Rect *pr);
			ResetScrollBars(int i);
			CheckHiliteScrollBar(ControlHandle ch, Boolean ControlActive);
			BBHiliteControls(int i, Boolean ControlActive);
			HiliteTextScrollBar(int windex, Boolean Activate_It);
	int		GetTextScrollMax(int windex);
			SetTextScrollMax(int windex, int NumHiddenLines, Boolean SetValue);
			SetTextScrollPage(int windex, int LinesPerPage);
	int		GetTextScrollValue(int windex);
	int		TextScrollValueFromBottom(int windex);
	int		SetRelScrollVal(ControlHandle ch, int dhv);
			IncTextScrollValue(int windex, int LinesToScroll);
			ScrollWindowGraphics(int windex, int HScrollAmount,
					int VScrollAmount);
			ScrollWindow(int windex, int HScrollAmount, int VScrollAmount);
			ScrollWindowOneDirection(int windex, ControlHandle ch,
					int ScrollAmount);
	pascal	void	MyScrollBarAction(ControlHandle ch, int partCode);
			HandleScrollBar(int windex, ControlHandle ch, int partCode,
				Point pt);
	Boolean	HandleHotSpot(ControlHandle ch, Point pt);
	int		GetWhichHotSpot(int windex, ControlHandle ch);
	Boolean	HandleControl(int i, Point pt, int *pWhichHotSpot);
			ActivateAnimaHS(Boolean TurnOn, Rect *pBall, Rect *pTable);
	pascal	long	HotSpotControlDef(int varCode, ControlHandle ch,
				int message,long param);
			CreateHotSpots(int windex, int num);
			InitBBControls(void);

/*	From bbWindows.c	*/
	int		WindowIndex(WindowPtr wp);
	Boolean	WindowOpen(int windex);
	Boolean	IsMagnified(int windex);
	Size	WindowLocsSize(int n);
			WindowMoveTo(int i, int x, int y);
			WindowLineTo(int i, int x, int y);
			BackMoveTo(int i, int x, int y);
			BackLineTo(int i, int x, int y);
			BothMoveTo(int i, int x, int y);
			BothLineTo(int i, int x, int y);
	int		xFloatToCoord(int i, double f);
	int		yFloatToCoord(int i, double f);
	double	xCoordToFloat(int i, int Coord);
	double	yCoordToFloat(int i, int Coord);
	Fixed	xFloatToFixed(int i, double f);
	Fixed	yFloatToFixed(int i, double f);
			BBForceUpdate(WindowPtr wp);
			BBSizeWindow(WindowPtr wp, int h, int v);
			BBOpenWindow(WindowPtr wp);
			BBCloseWindow(WindowPtr wp);
	Boolean	BBCloseFrontWindow(void);
			BBCloseAllWindows(void);
			BBZoomWindow(Point Where, WindowPtr WhichWindow, int Part);
			MakeLargeWindow(WindowPtr wp);
			BBGrowWindow(Point pt, WindowPtr WhichWindow);
			BBDragWindow(Point pt, WindowPtr WhichWindow, int mods);
			BBGoAwayWindow(Point pt, WindowPtr WhichWindow);
			BBHandleActivate(WindowPtr wp, int ActivateFlag);
			SelectWindowIndex(int i);
			SetOpenWindows(void);
			DefaultWindowConfiguration(void);
	Boolean	GetDefaultWindowConfiguration(Boolean AtStartup);
			InitialWindowConfiguration(Boolean PrintingOnly);
			SetCurWindows(int windex);
			SetDefaultWindowConfiguration(void);
			AddWindowsToMenu(void);
			SetTextTitle(Boolean FileExists, int windex);
			GetTextTitle(char *theTitle);
	int		SelectOrderIndex(int i);
			ArrangeWindows(void);
			InitWindowArrangement(void);
			NewBBWindow(int windex);
			NewBBWindows(Boolean ClearSolutions);
	Boolean	InitBBOffPorts(void);
			InitBBWindows(void);
			HaltBBWindows(void);

/*	From bbContGraphics.c	*/
			MakeSineWave(void);
			GetSimulationSpeed(void);
			SwitchScrollTrajectory(void);
			ForceRefreshTraj(void);
			SetTrajTimeOffset(double theHitTime);
			InitTrajScales(void);
			SetTrajCoords(void);
			SetWholeScreenTrajCoords(void);
			DrawTrajBackground(void);
			RefreshTraj(void);
			InitTrajGraphing(double Xi, double Vi, double Ti, int yint);
			GraphTrajectory(Boolean IsStuck, int *pxint, int yint);
	Boolean	ToggleFasterPhaseSpace(void);
			ClearPhaseSpace(void);
			InitPSScales(void);
			InitWholeScreenPSCoords(void);
			SetPSCoords(void);
			DrawPSBackground(void);
			RefreshPS(void);
			InitAnimationParts(void);
			DrawAnimation(Boolean DrawingWholeThing);
			Animate(int xint, int yint);
			DrawAnimationFrame(void);
			RefreshAnimation(void);
			ResetTSVars(double time);
			ToggleUseTimeSeries(Boolean CheckWindow);
			GetTimeSeriesInfo(void);
			ClearTimeSeries(void);
			SeeIfWantTS(Boolean ToStart);
			GraphTimeSeries(double time, double Ti, double Xi, double Vi,
					Boolean IsStuck);
			SetContGraphingClipping(Boolean StartingToGraph);
			GraphFrom(double Ti, double Tj, double Xi, double Vi);
			GraphStuckBall(double Ti, double Tj);
			NewContGraphics(void);
			InitContGraphics(void);

/*	From bbImpactGraphics.c	*/
	double	GetVelRatio(double theVelocity);
			SetVMax(Boolean RecalcAuto);
			GetNewVMax(void);
			SetImpactMapStart(int theHitNumber);
	double	GetOffsetPhase(double del);
	double	GetUnOffsetPhase(double del);
			SetPhaseRangeGlobals(int theMinPhaseInt);
			GetPhaseRange(void);
			InitFullIMapRange(void);
			SetFullIMapRange(void);
			GetIMMagnification(Boolean SkipDialog);
	Boolean	TrackIMapRect(Point pt, double *pv0, double *pdelta);
			InitImpactMapScales(void);
			PlotInImpactMap(double del, double vel, Boolean Highlighting);
			RefreshIM(int myHitNumber);
			GetImpactPhasesOffset(void);
			InitFullIPhsRange(void);
			SetFullIPhsRange(void);
			GetIPMagnification(Boolean SkipDialog);
	Boolean	TrackIPhsRect(Point pt);
			InitImpactPhaseScales(void);
			PlotImpactPhases(double del, double time, int myHitNumber,
				Boolean Highlighting);
			RefreshIP(int myHitNumber);
	Boolean	AddGraphicSolution(int hitnum, double thePhase, double velocity,
				double time, int StickyState, int PS);
			NewImpactGraphics(void);
			InitImpactGraphics(void);
			HaltImpactGraphics(void);

/*	From bbGraphics.c	*/
			StartWaiting(void);
			StopWaiting(void);
	int		FindBBClick(int i, Point pt);
			HandleUpdate(WindowPtr wp, int myHitNumber);
			MakePicture(int windex, GrafPtr gp, Rect *pDstRect);
			HandlePICTCopy(int windex);
			HandleCopy(int windex);
			NewGraphics(Boolean ClearSolutions, Boolean NeedToResetFileName);
	Boolean	InitGraphics(void);
			CreateWindowRecords(void);
			HaltGraphics(void);

/*	From bbBasAttr.c	*/
	double	GetBAOffsetPhase(double del);
	double	GetBAUnOffsetPhase(double del);
	int		GetDefaultMaxTimes(double theDamping);
	Boolean	CreateBAOffPort(int WhichOP, Rect *pr, int StepSize);
	Boolean	CreateBAOffPorts(Rect *pr, int StepSize);
			ChangeBAPhaseRange(double NewMinPhase);
	Boolean	InitNextBA(void);
	Boolean	GetNextBA(Boolean *pShouldAdvance);
			StartBasinsOfAttraction(void);
			ContinueBasinsOfAttraction(void);
			GetBasAttrInfo(Boolean Magnifying);
	Boolean	TrackBARect(Point pt);
	Boolean	InitBAScales(void);
			DrawCurrentBABackground(void);
			DrawBABackground(void);
			RefreshBA(void);
			SetBASolutionType(int SolType);
			CheckBAPeriodicity(void);
			BACopyBits(int SrcPortIndex, int DstPortIndex, int theMode);
			CopyBAGraph(Rect *pr, int h, int v);
	Boolean	TestBAPoint(int WhichPort, int xCoord, int yCoord);
	int		FindPrevBASolution(int xCoord, int yCoord);
	Boolean	MiddleOfBasin(int WhichBasin, int xCoord, int yCoord);
			PlotBAPoint(int WhichPort, int xCoord, int yCoord);
			HiliteBAImpact(int xCoord, int yCoord);
			PlotInBA(int xCoord, int yCoord);
			GetBAPlot(double del, double vel, Point *ppt);
	Boolean	UpdateBAOffPorts(void);
			DrawBAComposite(void);
			GraphBA(void);
			ClearBasinsOfAttraction(void);
	Boolean	SaveBAReturn(Boolean SaveOKSoFar);
	Boolean	SaveBAFile(void);
	Boolean	BadOpenBAReturn(void);
	Boolean	OpenBAFile(void);

/*	From bbBifDiag.c	*/
	double	GetBDOffsetPhase(double del);
	double	GetBDUnOffsetPhase(double del);
	int		GetDefaultInitIterTimes(double theDamping);
			CopyBDGraph(Rect *pr, int h, int v);
			ChangeBDPhaseRange(double NewMinPhase);
	Boolean	InitNextBD(void);
	Boolean	GetNextBD(void);
			StartBifurcationDiagram(void);
			ContinueBifurcationDiagram(void);
			GetBifDiagInfo(Boolean Magnifying);
	Boolean	TrackBDRect(Point pt);
	Boolean	InitBDScales(void);
			DrawCurrentBDBackground(void);
			DrawBDBackground(void);
			RefreshBD(void);
			PlotInBD(int yCoord);
	int		GetBDYPlot(double del, double vel);
			SetBDSolutionType(int SolType);
			CheckBDPeriodicity(void);
			GraphBD(void);
			ClearBifurcationDiagram(void);
	Boolean	SaveBDReturn(Boolean SaveOKSoFar);
	Boolean	SaveBDFile(void);
	Boolean	BadOpenBDReturn(Boolean IsMemError);
	Boolean	OpenBDFile(void);

/*	From bbSpecial.c	*/
				SeeIfStopSpecial(int windex);
	Boolean		SpecialGraphing(void);
	int			GetSpecialTimes(int theTimes, int DefaultTimes);
				SpecialMenuEnable(int windex, Boolean TurnOn, Boolean PauseOK);
				CheckGraphInAll(int windex);
				SwitchGraphInAll(int windex);
				CheckSpecialColor(int windex);
				SwitchInColor(int windex);
				SetSpecialTitle(Boolean FileExists, int windex);
				StringAddVar(char *s, double f, char *label, Boolean MorePrecision);
				StringAddVarLn(char *s, double f, char *label, Boolean MorePrecision);
	Boolean		CreateSpecialOffPort(GrafPtr *pgp, Rect *pr);
				GetSpecialPhaseRange(int windex);
				HandleSpecialHotSpot(int windex, int WhichHotSpot);
	Boolean		TestAdjacents(double y0, double y1, double y2, double y3,
						int per, int k, int InfoType, Boolean IsAlternating);
	Boolean		TestPeriodicity(int per, Boolean *pWillBePeriodic,
						Boolean *pProbablyPeriodic);
	PicHandle	MakeSpecialPicture(GrafPtr gp);
	Boolean		SaveSpecialFile(int theWindex);
	Boolean		OpenSpecialFile(int theWindex);
	Boolean		LoadSolutionPatterns(void);
				GetSolutionPatterns(void);
				SetSpecialColor(int i, Boolean UseRGBValues);
				InitSpecialColors(void);
				GetSolutionColors(void);
				SetSpecialControls(int windex);
	Boolean		FindSpecialClick(int windex, Point pt);
				SetSpecialScrolling(int windex);
				ScrollCopyBackRect(int windex, Rect *pr, Boolean ToWindow);
				ScrollCopyBackToWindow(int windex);
				CopySpecialBackToPrint(int windex);
				NewSpecial(int windex);
				InitSpecial(void);

/*	From bbSpecialDialog.c	*/
	Boolean		DoSpecialWarningDialog(char *ps);
	Boolean		DoSpecialOpenContinueDialog(char *ps);
	Boolean		DoSpecialCloseStopDialog(char *ps);
	Boolean		DoSpecialClearDialog(char *ps);
	Boolean		ReplaceSolutionInfoDialog(char *ColOrPat, char *SpecialType);
				DoGraphInAllAlert(int windex);
	Boolean		BifDiagDLogItemFilter(DialogPtr dp, int itemHit);
	Boolean		CheckBifurcationDiagramDialog(DialogPtr dp, int itemNo);
	Boolean		DoBifurcationDiagramDialog(Boolean *StartIt);
	Boolean		BasAttrDLogItemFilter(DialogPtr dp, int itemHit);
	Boolean		CheckBasinsOfAttractionDialog(DialogPtr dp, int itemNo);
	Boolean		DoBasinsOfAttractionDialog(Boolean *StartIt,
				DoubleRect *pNewGraphRange);
	pascal		void	DrawSolColsRoutine(WindowPtr wp, int itemNo);
	pascal		void	DrawSolPatsRoutine(WindowPtr wp, int itemNo);
	Boolean		SolutionItemFilterProc(DialogPtr dp, int itemHit);
	DialogPtr	GetSolutionInfoDialog(void);
	Boolean		DoSolutionInfoDialog(Boolean DoingColor);
