#include <SoundDvr.h>
#include <SoundUtils.h>
#include <MusicUtils.h>
#include "bbPrototypes.h"
#include "bbMenus.h"

#define	BaseTone		512
#define	StdTime			5		/* in ticks--1/60ths of a second */
#define	Synchronous		-1L
#define Asynchronous	0L

extern	hBBPreferences		hBBPrefs;
extern	MenuHandle			SimpleSoundMenuH, AdvancedSoundMenuH, SoundMenuH;

unsigned char				SoundSineWave[256];

/*	NOTE: Rascal version beta had commented-out section here
 *	which handled the SoundMenu.
 */

InitSounds()
{
	SetNumOctaves(NumOctaves);

	MakeSoundSine((unsigned char *) &SoundSineWave);

	InitOctave(BaseTone);
}

FlipTonesOn(int SMenuItem)
{
	switch (SMenuItem) {
		case 1:	{
			PhaseTonesOn = !PhaseTonesOn;
			CheckItem(SimpleSoundMenuH, SMenuItem, PhaseTonesOn);
			CheckItem(AdvancedSoundMenuH, SMenuItem, PhaseTonesOn);
			break;
		}
		case 2:	{
			VelTonesOn = !VelTonesOn;
			CheckItem(SimpleSoundMenuH, SMenuItem, VelTonesOn);
			CheckItem(AdvancedSoundMenuH, SMenuItem, VelTonesOn);
			break;
		}
	}
}

SetNumOctaves(int i)	{	NumOctaves = i;	}

SetToneMode(int WhichMode)
{
	CheckItem(SoundMenuH, CurrentMode, FALSE);
	CurrentMode = WhichMode;
	CheckItem(SoundMenuH, CurrentMode, TRUE);
}

int GetTone(thePhase, prevHit, Hit, thePeriod, Compare)
	double	thePhase, prevHit, Hit, thePeriod;
	Boolean Compare;
{
	double	DeltaHit;
	int		theTone;

	switch (CurrentMode) {
		case MajorMode:
				theTone = GetMajorTone(thePhase);					break;
		case MinorMode:
				theTone = GetMinorTone(thePhase);					break;
		case ChromaticMode:
				theTone = GetChromaticTone(thePhase);				break;
		case ContinuousMode:
				theTone = GetContinuousLogTone(BaseTone, thePhase);	break;
	}

	if ((NumOctaves == 3) && Compare) {
		if ((DeltaHit = Hit-prevHit) < thePeriod) theTone /= 4;
		else
			if (DeltaHit < 2.0 * thePeriod) theTone /= 2;
	}
	else theTone /= 2;

	return(theTone);
}

MakeTone(thePhase, velocity, prevHit, Hit, thePeriod, Compare)
	double	thePhase, velocity, prevHit, Hit, thePeriod;
	Boolean	Compare;
		/*	thePhase is between 0 and 1;
		 *	tone returned by GetTone will be between BaseTone/2 and
		 *	BaseTone Hz, unless three octave option is on, in which case
		 *	tone will be between BaseTone/4 and BaseTone*2 Hz.
		 */
{
	int		freq1, freq2;

	if (!( PhaseTonesOn || VelTonesOn )) return;

	freq1 = (PhaseTonesOn) ?
			GetTone(GetOffsetPhase(thePhase),prevHit,Hit,thePeriod,Compare) : 0;
	freq2 = (VelTonesOn) ?
			GetTone(GetVelRatio(velocity),prevHit,Hit,thePeriod,FALSE) : 0;

/*
	Note(freq1, StdAmplitude, StdTime, Synchronous);
*/
	if ( (freq1 != 0) || (freq2 != 0) )
		FourTone(StdTime, freq1, freq2, 0, 0,
				CP(SoundSineWave), (char *) Synchronous);
}