/*	bbSpecial.h
 *
 *	Include file for Bouncing Ball's "special" capabilities,
 *	Bifurcation Diagram and Basins of Attraction.
 *
 *		-TA 2/12/91
 */

#include <color.h>
#include <ColorToolbox.h>

#define	FirstBDPicture		1101
#define	FirstBAPicture		1201

#define	MIN_StepSize		1
#define	MAX_StepSize		8
#define	DEFAULT_StepSize	(MIN_StepSize)

#define	BaseInitIterTimes	80
#define	AddedInitIterTimes	20		/*	Default = Base * damp + Added	*/
#define	MaxCIITimesIncs		40
#define	BaseMaxTimes		(BaseInitIterTimes*2)
#define	AddedMaxTimes		(AddedInitIterTimes)	/*	Default = Base * damp + Added	*/
#define	MaxCMTimesIncs		(MaxCIITimesIncs)
#define	AutoTimes			-1
#define	MinAutoShow			20
#define	AutoShowMultiplier	3
#define	DiffSolutionInc		16
#define	MinProbableCount	10

#define	BA_CorrectGuessSol	4

#define	SpecialFieldWidth	(TxOutFieldWidth-1)
#define	SpecialPrecision	(SpecialFieldWidth-1)

#define BD_BottomMargin		(ScrollBarWidth + 3*StdMargin + 4*TextLineHeight + 2*TextHeight - 2)
#define	BD_MinSize			16

#define BA_BottomMargin		(BD_BottomMargin)

#define	MinSpecialLabelSeparation	3

#define	BETWEEN(b,a,c)		( ((b)-(a)) * ((b)-(c)) <= 0 )
/*	a must be less than c
((b)>=(a)) && ((b)<=(c)) )
*/

#define	BlackColorIndex				0

		/*	Basins of Attraction OffPort Indices	*/
enum {
		CurIterBAOP = NumSolutionTypes,
		AllBAOP,
		CompBAOP,
		ScratchBAOP,
		NumBAOffPorts
};

typedef struct {
			double			vel, del;	/*	Same as in Solutions...	*/
		}	ImpactSet;

typedef struct {
			IterationVars	Vars;
			GrafPtr			Graph;
			int				CurrentXInt, MaxXInt;
			Boolean			XAxisIsAmplitude, YAxisIsPhase;
			DoubleRect		XAxis, YAxis;
			double			v00, delta0;
			double			MinPhase;
			int				DefaultIITimes, InitIterTimes;
			int				ShowTimes;
			Boolean			AllPhases;
			Boolean			GraphInAllWindows, FullWindow, InColor;
			Rect			WindowSize;
								/*	Init. cond. at each x-value	*/
			ImpactSet		**InitConds;
								/*	Solution types--first CurrentXInt, type	*/
			int				MaxDiffSolutions, DiffSolutions;
			Point			**SolutionTypes;	/* h CurrentXInt, v type */
			Rect			HS0_Rect, HS1_Rect;
			Rect			LocalGR;
			long			Reserved1, Reserved2, Reserved3, Reserved4;
		}	BifDiagRecord, *pBifDiagRecord;

typedef struct {
			IterationVars	Vars;
			GrafPtr			Graphs[NumBAOffPorts];
			int				CurrentXInt, CurrentYInt;
			int				MaxXInt, MaxYInt;
			int				StepSize;
			double			MinPhase;
			int				DefaultMaxTimes, MaxTimes;
			Boolean			AllPhases;
			Boolean			Faster;
			Boolean			GraphInAllWindows, FullWindow, InColor;
			Rect			WindowSize;
			Rect			HS0_Rect, HS1_Rect;
			Rect			LocalGR;
			long			Reserved1, Reserved2, Reserved3, Reserved4;
		}	BasAttrRecord, *pBasAttrRecord;
