/*	qm segment dealing with files: opening, saving
 */

#include <DialogUtils.h>
#include <FileUtils.h>
#include "qmPrototypes.h"

#define	QMSFType				'QMap'
#define	TextSFType				'TEXT'
#define	DefaultsSFType			'QMDF'
#define	BifDSFType				'QmBd'
#define	QMWindowsResType		'QMWn'
#define	QMPrefsResType			'QMDf'
#define	NumOpenFileTypes		2

enum {	DefaultWindowID = 128, DefaultPrefsID = DefaultWindowID, OpenWindowID };

/*
#define pSaveFName				(CP(SaveFName))
*/
#define	pDefaultsFName			(CP(DefaultsFName))
#define	DefaultDefaultsFName	"\PQuadratic Map Defaults"

#define	DelimiterStringResID	129
#define	TAB_Delimiter			"\P\t"
#define	COMMA_Delimiter			"\P, "
#define	CR_Delimiter			"\P\r"
#define	MIN_SPACES				2
#define	PARAM_LINES				1


		/*	From qm.c	*/
extern	hQMPreferences		hQMPrefs;
extern	Boolean				PrintingOnly;
		/*	From qmBifDiag.c, qmBasAttr.c	*/
extern	Boolean				DrawBD;

		/*	From qmWindows.c	*/
extern	WindowLocation		wd[NumWindows], CurWD[NumWindows];
extern	int					DefaultWindowNum, CurWindowNum;

int				SaveVRef, oSaveVRef;
int				BDSaveVRef;
myFileNameType	oSaveFName;
myFileNameType	NormalSaveFName;
myFileNameType	BDSaveFName;

/*	1.01 addition
 */
int				tmpVRef;
myFileNameType	tmpSaveFName;
/*	end, 1.01 addition
 */

int				SaveWindex;
int				OpenWindex;

char			*pSaveFName;
int				*pVRef;
char			*SaveAsPrompt;
OSType			SaveType;

Boolean			GoodSaveFName;
Boolean			GoodBDSaveFName;
int				Untitleds, BDUntitleds;

int				NumParamFiles, ParamFileCount;
Boolean			LastParamFile;

int		oDelimiterIndex;
char	DelimiterStrings[NUM_Delims][DelimDescLength];
char	*Delimiters[NUM_Delims];
long	LinesRead;	/*	used with CR-delimiter only	*/

int				SysVRef, DefaultsOpenVRef;
myFileNameType	DefaultsFName;

hWindowLocs		hWLs;
Size			hWLsSize;


SetANilFileName(int theWindex)
{
	switch (theWindex) {
		case BifD:
			BDSaveFName[0] = 0;	break;
		default:
			NormalSaveFName[0] = 0;
			break;
	}
}

SetNilFileNames()
{
	NormalSaveFName[0] = BDSaveFName[0] = oSaveFName[0] = 0;
}

char *GetSaveFName(int windex)
{
	switch(windex) {
		case BifD:	return(CP(BDSaveFName));
		default:	return(CP(NormalSaveFName));
	}
}

SetFileName(int theWindex)
{
	SaveWindex = theWindex;
	switch (theWindex) {
		case BifD:
					pSaveFName = CP(BDSaveFName);
					pVRef = &BDSaveVRef;
					SaveAsPrompt = "\PSave bifurcation diag. as:";
					SaveType = BifDSFType;
					break;
		default:
					pSaveFName = CP(NormalSaveFName);
					pVRef = &SaveVRef;
					SaveAsPrompt = "\PSave impact data as:";
					SaveType = TextSFType;
					break;
	}
}

int DecideWhichSaveWindow()
{
	int	theWindex;

	switch (theWindex = WindowIndex(FrontWindow())) {
		case BifD:	if (!DrawBD)	theWindex = TxOut;	break;
		default:	theWindex = TxOut;					break;
	}
	SetFileName(theWindex);
	return(theWindex);
}

InitQMFiles()
{
	int	i;

/*
	DelimiterIndex = SPACE_Delim;
*/
	for(i=FIRST_Delim;i<LAST_Delim;++i)
		GetIndString(DelimStr(i),DelimiterStringResID,i+1);
	Delimiters[SPACE_Delim]	= 	"\P";
	Delimiters[TAB_Delim]	= 	TAB_Delimiter;
	Delimiters[COMMA_Delim]	= 	COMMA_Delimiter;
	Delimiters[CR_Delim]	= 	CR_Delimiter;
	/*	SetNilFileNames(); */	/* Done in qmGraphics */
	SetNilFileNames();

	SysVRef = BootDrive;
	DefaultsOpenVRef = SysVRef;
	sEquate(pDefaultsFName, DefaultDefaultsFName);
/*
	DefaultsFileExists = FALSE;
*/
	GoodSaveFName = GoodBDSaveFName = TRUE;
	Untitleds = BDUntitleds = 0;
}

int	GetNextParamFile()
{
	AppFile	theAppFile;
	int		windex;
	char	*pfname;
	int		*pvref;

	for(;;) {
		if (++ParamFileCount > NumParamFiles) return(NoWindow);
		LastParamFile = (ParamFileCount == NumParamFiles);
		GetAppFiles(ParamFileCount, &theAppFile);
		switch (theAppFile.fType) {
			case BifDSFType:	
							pfname = CP(BDSaveFName);	pvref = &BDSaveVRef;
							windex = BifD;				break;
			case TextSFType:	
							pfname = CP(NormalSaveFName);	pvref = &SaveVRef;
							windex = TxOut;				break;
			default:
							continue;
		}
		break;
	}

	sEquate(pfname, CP(theAppFile.fName));
	*pvref = theAppFile.vRefNum;
	ClrAppFiles(ParamFileCount);	/*	only clear if handled successfully	*/
	return(windex);
}

int	QMGetParamFiles()
{
	int		appMessage;
	AppFile	theAppFile;
	int		i;
	Boolean	GotADefaultFile;

	CountAppFiles(&appMessage, &NumParamFiles);
	if (NumParamFiles == 0) return(NoAppFile);

	GotADefaultFile = FALSE;
	if (appMessage != appPrint)
		for(i=NumParamFiles; i>=1; --i) {
			GetAppFiles(i, &theAppFile);
			if (theAppFile.fType == DefaultsSFType) {
				if (!GotADefaultFile) {
					sEquate(pDefaultsFName, CP(theAppFile.fName));
					DefaultsOpenVRef = theAppFile.vRefNum;
					GotADefaultFile = TRUE;
				}
				ClrAppFiles(i);
			}
		}

	ParamFileCount = 0;
	return(appMessage);
}

/*
CallHelp()
{
	Help("\PQuadratic Map Help", 0);
}
*/

Boolean	QMGetFileLine(char *theLine)
{
	Boolean GoodLine;
	Str255	NextLine;
	int		i;

	GoodLine = ReadTextFileLine(theLine);
	if (DelimiterIndex == COMMA_Delim)
		sSubstC(theLine, ',', SPACE);
	if ( (DelimiterIndex != CR_Delim) || (!GoodLine) )
		return(GoodLine);

		/*	Only get here if CR_Delim, GoodLine	*/
	++LinesRead;
	RETURN_IF_FALSE( ReadTextFileLine(CP(NextLine)) );
	theLine[theLine[0]] = SPACE;
	sAppend(theLine, CP(NextLine));
/*
	if (LinesRead > PARAM_LINES)
		for (i=1; i<=2; ++i) {
			RETURN_IF_FALSE( ReadTextFileLine(CP(NextLine)) );
			theLine[theLine[0]] = SPACE;
			sAppend(theLine, CP(NextLine));
		}
*/
	return(TRUE);
}

Boolean CheckFirstLine(char *theLine)
/*	Returns FALSE if a Time Series file, TRUE (and sets delimiter) otherwise	*/
{
	int	i;

	if ( StrFind("\pmbda", theLine) ) {
		ResetFileRead();
		return(TRUE);
	}
	for (i=TAB_Delim; i<=CR_Delim; ++i)
		if ( StrFind(DelimStr(i), theLine) ) {
			DelimiterIndex = i;
			break;
		}
	if (DelimiterIndex == CR_Delim)
		LinesRead = 0;
	return(TRUE);
}

CloseOpenFile()
{
	if (OpenWindex == BifD)
		if (!StopResFile())
			;
	StopFileRead();
}

Boolean GetOpenWindows()
{
	int			i;

	hWLs = (hWindowLocs) GetResource(QMWindowsResType, OpenWindowID);
	if (hWLs != NIL) {
		CurWindowNum = (**hWLs).num;
		for(i=0; i<CurWindowNum; ++i)
			CurWD[i] = (**hWLs).ws[i];
	}
	hWLsSize = GetHandleSize((Handle) hWLs);

	if (OpenWindex == TxOut)
		if (!StopResFile())
			;
	return(hWLs != NIL);
}

Boolean	OpenFile()
{
	Boolean	ResForkExists;

	SetFileName(OpenWindex);
	RETURN_IF_FALSE( StartFileRead(*pVRef, pSaveFName, FALSE) );
	if (OpenWindex == TxOut) {
		oDelimiterIndex = DelimiterIndex;
		DelimiterIndex = SPACE_Delim;
	}
	if (!OpenResFork(pSaveFName, *pVRef, OpenWindex != TxOut, &ResForkExists)) {
		StopFileRead();
		return(FALSE);
	}
/*
	RETURN_IF_FALSE( OpenResFork(pSaveFName, *pVRef) );
*/
	if (!PrintingOnly)
		if (ResForkExists)
			if (GetOpenWindows())
				if (OpenWindex == TxOut)
					SetOpenWindows();
	return(TRUE);
}

ResetDelimiter()
{
	DelimiterIndex = oDelimiterIndex;
}

Boolean	GetOpenFileName(int *pwindex)
{
	OSType	theTypes[NumOpenFileTypes], fType;
/*	1.01 deletion
	Str255	s;
	int		vref;
*/

	theTypes[0] = TextSFType;
	theTypes[1] = BifDSFType;
/*	1.01 change
	RETURN_IF_FALSE( QMOpenDialog((OSType *) &theTypes,
			NumOpenFileTypes, &vref, CP(s), &fType) );
*/
	RETURN_IF_FALSE( QMOpenDialog((OSType *) &theTypes,
			NumOpenFileTypes, &tmpVRef, CP(tmpSaveFName), &fType) );
/*	end, 1.01 change
 */

	switch (fType) {
		case TextSFType:
/*	1.01 deletion
						SaveVRef = vref;
						sEquate(CP(NormalSaveFName), CP(s));
*/
						OpenWindex = TxOut;
						break;
		case BifDSFType:
/*	1.01 deletion
						BDSaveVRef = vref;
						sEquate(CP(BDSaveFName), CP(s));
*/
						OpenWindex = BifD;
						break;
	}

	*pwindex = OpenWindex;
	return(TRUE);
}

/* New 1.01 routine
 */

SetOpenFileName(int windex)
{
	switch (windex) {
		case TxOut:
						SaveVRef = tmpVRef;
						sEquate(CP(NormalSaveFName), CP(tmpSaveFName));
						break;
		case BifD:
						BDSaveVRef = tmpVRef;
						sEquate(CP(BDSaveFName), CP(tmpSaveFName));
						break;
	}
}

/*	End, new 1.01 routine
 */

ResetFileName()
{
	sEquate( pSaveFName, CP(oSaveFName) );
	*pVRef = oSaveVRef;
}

GetTitleString(int theWindex, char *ts)
{
	sEquate(ts, "\pQuadratic Map");
	if (DelimiterIndex != SPACE_Delim) {
		sInsertC(ts, '/', (int) ts[0]+1);
		sAppend(ts, DelimStr(DelimiterIndex));
		sAppend(ts, "\P-delimited");
	}
	sInsertC(ts, RETURN_CHAR, (int) ts[0]+1);
}

Boolean CloseSaveFile(Boolean NeedToDelete)
{
	Boolean	GoodOp = TRUE;

	if (!StopFileSave())
		GoodOp = FALSE;

	if (SaveWindex == BifD)
		if (!StopResFile())
			GoodOp = FALSE;
/*
	if (GetHandleSize((Handle) hWLs) != 0L)
*/
/* deleted 11/11/91--was causing resource problems?
	if ( (GetHandleSize((Handle) hWLs) == hWLsSize) &&
			(hWLsSize != 0L) )
		DisposHandle((Handle) hWLs);
*/
	if (NeedToDelete)
		if (DeleteSaveFile()) ;
	return(GoodOp);
}

Boolean SaveCurWindows()
{
	int			i;
/*
Str255 s;
ResType theType;
int theID;
int	theError;
*/

	hWLs = (hWindowLocs) NewHandle(WindowLocsSize(CurWindowNum));
	if (hWLs == NIL) return(FALSE);
	(**hWLs).num = CurWindowNum;
	for(i=0; i<CurWindowNum; ++i)
		(**hWLs).ws[i] = CurWD[i];
	hWLsSize = GetHandleSize((Handle) hWLs);
/*
GetResInfo((Handle) hWLs, &theID, &theType, (char *) &s);
theError = ResError();
*/
	RETURN_IF_FALSE( AddNewResource((Handle) hWLs, QMWindowsResType,
			OpenWindowID) );
/*
GetResInfo((Handle) hWLs, &theID, &theType, (char *) &s);
theError = ResError();
*/

	return(TRUE);
}

Boolean SaveFile()
{
	int			i;
	long		TotalAmt, TEWriteStart;
	int			NumSpaces = 0;
	char		*ds = Delimiters[DelimiterIndex];
	Str255		TitleString;
	QMTextPtr	CurText;
	int			DefaultVol;
	Str255		s;
	Boolean		ResForkExists;

	RETURN_IF_FALSE( StartFileSave(pSaveFName, *pVRef) );

	hWLs = NIL;
	RETURN_IF_FALSE( OpenResFork(pSaveFName, *pVRef, TRUE, &ResForkExists) );
	SetCurWindows(SaveWindex);
	RETURN_IF_FALSE(SaveCurWindows());
	switch (SaveWindex) {
		case BifD:	return(SaveSpecialFile(SaveWindex));
		case TxOut:	RETURN_IF_FALSE(StopResFile());
	}
	CurText = GetTextFromTindex(GetTextIndex(SaveWindex));
	GetTitleString(SaveWindex, CP(TitleString));
	RETURN_IF_FALSE( WritePtrToFile(CP(TitleString) + 1,
			(long) TitleString[0]) );

	RETURN_IF_FALSE( Delim_WriteTEtoFile(CurText->header, 0L,
			ds, 1, &NumSpaces, FALSE, FALSE) );

		/* Handle "overflow", for > 32K chars */
	NumSpaces = MIN_SPACES+1;
	if (CurText->OF.index > 0L) {
		for (i=0; i<=CurText->OF.index / BodyOFIncrement; ++i) {
			TotalAmt = (CurText->OF.index >= (i+1)*BodyOFIncrement) ?
					BodyOFIncrement : CurText->OF.index % BodyOFIncrement;
			RETURN_IF_FALSE( Delim_WriteHandleToFile(CurText->OF.hands[i],
					TotalAmt, ds, MIN_SPACES, &NumSpaces, FALSE, FALSE) );
		}
		TEWriteStart = (long) (**CurText->body).lineStarts[OVERFLOW_MSG_LINES];
	}
	else
		TEWriteStart = 0L;

	RETURN_IF_FALSE( Delim_WriteTEtoFile(CurText->body, TEWriteStart,
			ds, MIN_SPACES, &NumSpaces, FALSE, FALSE) );

	RETURN_IF_FALSE( CloseSaveFile(FALSE) );

	return(TRUE);
}

GetUntitledFileName(char *ps)
{
	switch (SaveWindex) {
		case BifD:	sprintf(ps, "Bifurcation Diagram %d", ++BDUntitleds);
					break;
		default:	sprintf(ps, "Untitled %d", ++Untitleds);
					break;
	}
	CtoPstr(ps);
}

SetGoodSaveFName(Boolean NewGoodSaveFName)
{
	switch (SaveWindex) {
		case BifD:	GoodBDSaveFName = NewGoodSaveFName;	break;
		default:	GoodSaveFName = NewGoodSaveFName;	break;
	}
}

Boolean	GetGoodSaveFName()
{
	switch (SaveWindex) {
		case BifD:	return(GoodBDSaveFName);
		default:	return(GoodSaveFName);
	}
}

Boolean	SaveAs()
{
	Str255	s;

	if (pSaveFName[0] == 0)
		GetUntitledFileName(CP(s));
	else
		sEquate(CP(s), pSaveFName);

	sEquate (CP(oSaveFName), pSaveFName);
	oSaveVRef = *pVRef;

	if (SaveWindex == BifD) {
		if ( !QMSpecialSaveAsDialog(SaveAsPrompt, pVRef, CP(s)) ) {
			if (pSaveFName[0] == 0)
				--BDUntitleds;
			return(FALSE);
		}
	}
	else if ( !QMSaveAsDialog(SaveAsPrompt, pVRef, CP(s)) ) {
		if (pSaveFName[0] == 0)
			--Untitleds;
		return(FALSE);
	}

	sEquate(pSaveFName, CP(s));

	if ( !StdCreateFile(pSaveFName, *pVRef, QMSFType, SaveType) ) {
		SetGoodSaveFName(FALSE);
		return(FALSE);
	}
	else
		SetGoodSaveFName(TRUE);

	return(TRUE);
}

Boolean	SaveFileExists()
{
	if (GetGoodSaveFName()) {
		RETURN_IF_FALSE( pSaveFName[0] > 0 );
		return( StdCreateFile(pSaveFName, *pVRef, QMSFType, SaveType) );
	}
	else
		return(FALSE);
}


		/*	----------------------------------------------------------	*/
		/*	----------	Routines Relating to defaults file	----------	*/
		/*	----------------------------------------------------------	*/

Boolean CreateDefaultsFile()
{
	OSErr	myErr;
	Boolean	ResForkExists;

	sEquate(pDefaultsFName, DefaultDefaultsFName);
	RETURN_IF_FALSE( StdCreateFile(pDefaultsFName, SysVRef, QMSFType,
			DefaultsSFType));
	return( OpenResFork(pDefaultsFName, SysVRef, TRUE, &ResForkExists) );
}

Boolean OpenDefaultsFile()
{
	Boolean	ResForkExists;

	RETURN_IF_FALSE( OpenResFork(pDefaultsFName, SysVRef, FALSE, &ResForkExists) );
	return(ResForkExists);
}

CloseDefaultsFile()
{
	if (!StopResFile()) ;
}

Boolean OpenDefaults(Boolean *pGotPrefs)
{
	int			i;

	*pGotPrefs = FALSE;
	RETURN_IF_FALSE(OpenDefaultsFile());

	hWLs = (hWindowLocs) GetResource(QMWindowsResType, DefaultWindowID);
	if (hWLs == NIL)
		return(FALSE);
	DefaultWindowNum = (**hWLs).num;
	for(i=0; i<DefaultWindowNum; ++i)
		wd[i] = (**hWLs).ws[i];
	hWLsSize = GetHandleSize((Handle) hWLs);

	ResrvMem(sizeof(QMPreferences));
	hQMPrefs = (hQMPreferences) GetResource(QMPrefsResType, DefaultPrefsID);
	if (hQMPrefs != NIL) {
		*pGotPrefs = TRUE;
		DetachResource(hQMPrefs);
		HLock((Handle) hQMPrefs);	/*	almost always locked	*/
	}

	CloseDefaultsFile();
	return(TRUE);
}

Boolean SaveDefaultFile()
{
	int			i;

	RETURN_IF_FALSE( CreateDefaultsFile() );
	hWLs = (hWindowLocs) NewHandle(WindowLocsSize(DefaultWindowNum));
	(**hWLs).num = DefaultWindowNum;
	for(i=0; i<DefaultWindowNum; ++i)
		(**hWLs).ws[i] = wd[i];
	RETURN_IF_FALSE( AddNewResource((Handle) hWLs, QMWindowsResType,
			DefaultWindowID) );
	hWLsSize = GetHandleSize((Handle) hWLs);

	HUnlock((Handle) hQMPrefs);
	RETURN_IF_FALSE( AddNewResource((Handle) hQMPrefs, QMPrefsResType,
			DefaultPrefsID) );
	RETURN_IF_FALSE(UpdateResFork());
	DetachResource(hQMPrefs);
	HLock((Handle) hQMPrefs);

	CloseDefaultsFile();
/* removed 11/11/91--causing resource problems?
	if ( (GetHandleSize((Handle) hWLs) == hWLsSize) &&
			(hWLsSize != 0L) )
		DisposHandle((Handle) hWLs);
*/
	return(TRUE);
}


HaltQMFiles()
{
	;
}
