/*
 *	qmGraphics.h
 *
 *	Constants etc. for graphics files
 *
 *		-TA 11/8/90
 */

#define	NOPORT				( (GrafPtr) -1L )

#define	LWR_MARGIN			3
#define	LWR_TOP				(MBarHeight+MBarHeight+1)
#define	StdMargin			4
#define	TextHeight			9	/* Used mainly with Impact Map window */
#define	TextLineHeight		(TextHeight+2)
#define	Orbit_LeftMargin	15	/*	Not Used?	*/
#define	Orbit_TopMargin		(2*StdMargin+TextHeight)
#define	Orbit_RightMargin	(ScrollBarWidth+CharWidth('0')+2*StdMargin)
				/*	was 28	(* ScrollBarWidth + 2, + 10 for axis label *) */
#define	Orbit_BottomMargin	(ScrollBarWidth+TextHeight+2*StdMargin)
				/*	was 36	(* ScrollBarWidth + room for writing x0 *) */
#define	PS_TopMargin		(2*StdMargin + TextHeight + 3)
#define	BottomTextMargin	2
#define	HashSize			4
#define	TextMargin			4
#define	BodyTETop			24
#define	TxOutFieldWidth		12
#define	TxOutPrecision		(TxOutFieldWidth-1)
#define	TxOutWholePlaces	1
#define	PS_precision		4
#define	MANY_ITERATIONS		256
#define	HorAxisLabelHOffset	5
#define	VerAxisLabelVOffset	3

#define	StdPSFieldWidth			5
#define	PSPrecDiff				2
#define	PSRightMargin			(StdMargin + StringWidth("\P0.00")/2)
#define	PSLeftMargin			(StdMargin + 71)

#define	MAX_HotSpots			2	/*	NO_HotSpot defined in qm.h	*/

#define	RelPlaces				2	/*	Relative decimal places/mag.	*/
#define	MagnifyingGlassCursorID	130
#define	NumDashedLinePatterns	12

typedef struct {
	WindowPeek		Peek;
	GrafPtr			Back;				/*	Background Offport */
	double			xScale, yScale;
	DoubleRect		GraphRange;			/*	Only used if Magnifying	*/
	Rect			GR, PR;				/*	"GraphRect", "PinRect" */
	Rect			BackLimits;			/*	BackPort drawing limits,
										 *	for non-scalable windows */
	Point			Origin, BackOrigin;
	ControlHandle	RSB, BSB;			/*	Right/Bottom Scroll Bar	*/
	ControlHandle	HS[MAX_HotSpots];	/*	"Hot Spots"	*/
	Boolean			DrawFromScratch, Magnifying;
	Boolean			xGraphAroundZero, yGraphAroundZero;
	Boolean			WindowCleared;
	Boolean			ReservedBoolean;
	long			Reserved1, Reserved2, Reserved3, Reserved4;
}		QMWindow;
typedef	QMWindow	Windows[NumWindows];
