/*	qmIteration.c
 *
 *	Handles Quadratic Map's iteration
 *
 *	-TA 4/21/91
 */

#include	"qmPrototypes.h"

		/*	Returned by GetFileHeader, used in StartOpeningFile	*/
enum {
		GOOD_HEADER,
		TIME_SERIES_HEADER,
		BAD_HEADER
};

				/*	Global external vars from qm.c	*/
extern	IterationVars		NormalVars, *pCurrentVars;
extern	hQMPreferences		hQMPrefs;
								/*	External variables from qm.c	*/
extern	SolutionsHandles	mySolutions;
extern	int					ProgramStatus, LastProgramStatus;
extern	int					theEventMask, UsualEventMask;

								/*	From qmMenus.c	*/
extern	Boolean				NeedToSave;

								/*	From qmContGraphics.c	*/
extern	Boolean				RedrawSine;

								/*	From qmText.c	*/
extern	TEHandle			HeaderTE;

								/*	From qmBifDiag.c, for OKToGraph()	*/
extern	Boolean				*pBDGraphInAllWindows;
								/*	From qmSpecial.c, for InitNextIteration()	*/
extern	Boolean				NeedNextSpecialValue;
								/*	From qmGraphics.c, for opening	*/
extern	CursHandle			watch;


			/*	Global variables shared with qmGraphics.c	*/
Str255	CurrentLine, StuckLine;

			/* Iteration variables */
Str255	NextLine;


		/*	----------------------------------------------------------	*/
		/*	----------	Solution Method-Invariant Routines	----------	*/
		/*	----------------------------------------------------------	*/

SetHitNumber(int NewHitNumber)
{
	HitNumber = NewHitNumber;
	HitInd1 = SI1(HitNumber);
	HitInd2 = SI2(HitNumber);
}

Boolean SetItoJ(Boolean NeedPhase)
	/*	Used in NORMAL_ITERATION and PLAYBACK	*/
{
	xi = xj;
/*
	ti_Continuing = ti;
*/

/*
	if (StuckStatus == STUCK) {
		StopStickingMessage();
		StuckStatus = NOT_STUCK;
		return(FALSE);
	}
	else
*/
		return(TRUE);
}

SetInitConditions()
	/*	Used in PLAYBACK and OPENING	*/
{
	x0 = xj;
/*
	SetOrbitOffset(0);
*/
/*	I had deleted HitNumber>0 test; reinserted it because of
 *	double updating when start opening or playback.
 *	Did I delete it for some reason other than generality?
 *		-TA 12/26/90
 *	Need for v0, delta in Trajectory window; Animation window (?);
 *	other continuous windows (?)
 *		-TA 12/26/90
 */
/*
	if (HitNumber > 0) {
		NewGraphics(FALSE, FALSE);
		HandleAllUpdates();
	}
*/
	if (HitNumber > 0)
		NewGraphics(FALSE, FALSE);
/*
	else
		NewContGraphics();
*/
	HandleAllUpdates();
}

		/*	----------------------------------------------------------	*/
		/*	----------	First Solution Method: Iteration	----------	*/
		/*	----------------------------------------------------------	*/

Boolean InitNextIteration()
{
	if ( SetItoJ(TRUE) ) {
		if (xi == NEG_INFINITY) return(FALSE);
/*
		if ( !FindNStep(&ndt, ti, xi, vi) ) {
			if ( !HandleSticking( FindEjection(&ndt,&dt,&tj,&xj,&vj) ) )
				return(FALSE);
		}
		else dt = ndt;
*/
	}

	return(TRUE);
}

Boolean	Initialize_Iteration_Globals(Boolean BeginningIteration)
{
	if (!BeginningIteration) return(TRUE);

	CurHitNumber = -1;
/*	Moved to NewGraphics(TRUE, ...
	SetOrbitOffset(0);
*/

	xj = x0;

	return(TRUE);
}

Boolean Reset_Iteration_Globals()
	/* for "Continuing Iteration" */
{
/*
	ElapsedTime = HitTime = (**(mySolutions[HitInd1]))[HitInd2].time;
	xj = GetSolutionInfo(HitNumber);
	CurHitNumber = CHN_continuing;	/* ???	*)
*/
	return(InitNextIteration());
}

int IterateSolution()
{
	double	distance, theRoot;

/*
	if (StuckStatus == STUCK) {
		StartStickingMessage(StuckCount);
		return(FOUND_SOLUTION);
	}
*/

	if (CurHitNumber >= MaxIterations) {
		ERROR("\PMaximum number of iterations reached");
		return(BAD_SOLUTION);
	}

/*
	if (fabs(xi) > 1e30 (* say *)) {
		ERROR("\PSolutions too large");
		return(BAD_SOLUTION);
	}
*/

	xj = QuadraticMap(lambda, xi);
	return(FOUND_SOLUTION);
}

		/*	----------------------------------------------------------	*/
		/*	----------	Second Solution Method: Playback	----------	*/
		/*	----------------------------------------------------------	*/

Boolean InitPlayback()
{
	int		tmp_RealHitNumber, tmp_HitNumber = HitNumber;
	int		tmp_CHN = CurHitNumber;
	Boolean	oNeedToSave = NeedToSave;

	pCurrentVars = &NormalVars;
	tmp_RealHitNumber = MAX(RealHitNumber, HitNumber);
	RETURN_IF_FALSE(tmp_RealHitNumber>=0);
	SetHitNumber(-1);
	CurHitNumber = -1;
	SetOrbitOffset(0);
	NewGraphics(TRUE, FALSE);
	NeedToSave = oNeedToSave;	/*	set to FALSE by NewGraphics()	*/
	if ( !StartIterating(PLAYBACK) ) {	/* in for menu handling, other */
		SetHitNumber(tmp_HitNumber);
		CurHitNumber = tmp_CHN;
		return(FALSE);
	}
/*
	StuckCount = 0;
*/
	RealHitNumber = tmp_RealHitNumber;
/*
	ProgramStatus = PLAYBACK;
*/
	ti_Continuing = 0.0;
	return(TRUE);
}

GetPlaybackSolution()
{
/*
	if (StuckStatus == STUCK)
		StartStickingMessage(StuckCount);
*/

	SetHitNumber(++HitNumber);

	xj				= (**(mySolutions[HitInd1]))[HitInd2].x_n;
	CurHitNumber	= (**(mySolutions[HitInd1]))[HitInd2].curHN;
	if ( CurHitNumber == 0 ) {
/*
		StuckStatus = NOT_STUCK;
*/
		SetInitConditions();
	}
}

Boolean CheckNextPlayback()
{
	if ( SetItoJ(FALSE) ) ;

/*
	StuckStatus = (**(mySolutions[HitInd1]))[HitInd2].stuck;
	if (StuckStatus == STUCK) ++StuckCount;
*/
	return( HitNumber < RealHitNumber );
}

		/*	------------------------------------------------------	*/
		/*	----------	Third Solution Method: Opening	----------	*/
		/*	------------------------------------------------------	*/

StopOpeningFile(Boolean OpenOK)
{
	theEventMask = UsualEventMask;
	StopWaiting();

	CloseOpenFile();
	if (!OpenOK) {
		SetTextTitle(FALSE, TxOut);
		if (HitNumber < 0)
			NewGraphics(FALSE, FALSE);
/*
		else
			NeedToSave = TRUE;
*/
	}
	else
		NeedToSave = FALSE;
	if (HitNumber >= 0) {
/*
		ti_Continuing = HitTime;
*/
/* Bounding Ball relic; GraphWhileOpening should never be used.
		if (!GraphWhileOpening)
			SetOrbitOffset(CurHitNumber);
*/
	}
}

Boolean	GetFileParam(double *pf)
{
	Str255	theLine;
	int		ItemsRead;

	RETURN_IF_FALSE(QMGetFileLine(CP(theLine)));
	PtoCstr(CP(theLine));
	ItemsRead = sscanf(CP(theLine), "%*s %lf", pf);
	CtoPstr(CP(theLine));
	RETURN_IF_FALSE(ItemsRead == 1);
/*
	AppendText(CP(theLine), HeaderTE);
*/
	return(TRUE);
}

int	GetFileHeader()
{
	Str255	theLine;

	if ( !QMGetFileLine(CP(theLine)) )		return(BAD_HEADER);
	if ( !CheckFirstLine(CP(theLine)) )		return(TIME_SERIES_HEADER);

	if (!GetFileParam(&lambda))				return(BAD_HEADER);

	if ( !QMGetFileLine(CP(theLine)) )		return(BAD_HEADER);
/*
	AppendText(CP(theLine), HeaderTE);
*/
	SetHeaders(lambda);

	return(GOOD_HEADER);
}

Boolean StartOpeningFile()
{
	double	oLambda = lambda;
	int		HeaderStatus;

	pCurrentVars = &NormalVars;
	ResetSolutions();
	NewGraphics(TRUE, FALSE);
	InitHeaderTEs();
	StopIterating(ProgramStatus >= BIFURCATION_DIAGRAM);
	NeedToSave = FALSE;

	if (!StartingMemCheck()) {
		ERROR("\PNot enough memory to open file");
		SetTextTitle(FALSE, TxOut);
		SetHeaders(lambda);
		return(FALSE);
	}
	if (!OpenFile()) {
		ERROR("\POpen operation was not successful");
		SetTextTitle(FALSE, TxOut);
		SetHeaders(lambda);
		return(FALSE);
	}
	StartWaiting();
	if ( (HeaderStatus=GetFileHeader()) != GOOD_HEADER) {
		StopOpeningFile(FALSE);
		if (HeaderStatus == BAD_HEADER)
			ERROR("\PError: Not a Quadratic Map file");
		ResetDelimiter();
		lambda = oLambda;
		SetHeaders(lambda);
		return(FALSE);
	}

	NeedToSave = TRUE;
/*
	RETURN_IF_FALSE(Initialize_Iteration_Globals(TRUE));
	RETURN_IF_FALSE(InitNextIteration());
*/

	SetValuesFromSystemParams(oLambda);

	SetTextTitle(TRUE, TxOut);

	if (!QMGetFileLine(CP(NextLine))) {
		NextLine[0]=0;
		StopOpeningFile(TRUE);
		return(FALSE);
	}

	SetOrbitOffset(0);
	ActivateTextScrolls(FALSE);
	LastProgramStatus = ProgramStatus = OPENING;
	theEventMask = keyDownMask | updateMask | app4Mask;
	return(TRUE);
}

Boolean	GetFloats(char *Line, int *pchn, double *px)
{
	int		ItemsRead;

	PtoCstr(Line);
	ItemsRead = sscanf(Line, "%d %lf", pchn, px);
	CtoPstr(Line);
	return(ItemsRead == 2);
}

Boolean CheckForStuckOpen()
{
	return(TRUE);
/*
	int	OldStuckStatus;

	OldStuckStatus = NewStuckStatus;
	if (StrFind("\Pable", CP(NextLine)))
		NewStuckStatus = STUCK;
	else if (StrFind("\Porever", CP(NextLine)))
		NewStuckStatus = STUCK_FOREVER;
	else
		NewStuckStatus = NOT_STUCK;

	if (NewStuckStatus != NOT_STUCK) {
		sEquate(CP(StuckLine), CP(NextLine));
		if (!QMGetFileLine(CP(NextLine))) {
			NextLine[0] = 0;
			if (NewStuckStatus == STUCK) {
				NewStuckStatus = OldStuckStatus;
				return(FALSE);
			}
		}
		else if (NewStuckStatus == STUCK)
			++StuckCount;
	}
	return(TRUE);
*/
}

int GetOpenSolution()
{
	int		tmpCHN;
	double	tmpXj;
	Boolean	GoodSolution;

	sEquate(CP(CurrentLine), CP(NextLine));
	GoodSolution = GetFloats(CP(CurrentLine), &tmpCHN, &tmpXj);

	if (GoodSolution) {
		if (!QMGetFileLine(CP(NextLine))) NextLine[0] = 0;
		if (!CheckForStuckOpen())
			GoodSolution = FALSE;
	}

	if (!GoodSolution) {
		ERROR("\PUnable to open entire file");
		StopOpeningFile(FALSE);
		return(BAD_SOLUTION);
	}

/*
	if ( GraphWhileOpening && (StuckStatus == STUCK) )
		StartStickingMessage(StuckCount);
*/

	CurHitNumber = tmpCHN;
	xj = tmpXj;
/*
	if (GraphWhileOpening) {
		tj = HitTime;
		xj = xTable(tj);
	}
*/
	if ( CurHitNumber == 0 )
		SetInitConditions();
	return(FOUND_SOLUTION);
}

Boolean FinishedOpening()
{
	return( NextLine[0] == 0 );
}

Boolean CheckNextOpening()
{
	Boolean	Successful = TRUE;

	if ( FinishedOpening() ) {
		Successful = FALSE;
		StopOpeningFile(TRUE);
	}

	SetHitNumber(++HitNumber);
/*
	if (GraphWhileOpening) {
		if (SetItoJ(FALSE)) ;
	}
	else
*/
		xi = xj;
	StuckStatus = NewStuckStatus;

	return(Successful);
}

		/*	------------------------------------------------------	*/
		/*	----------	Inter-Solution Method Routines	----------	*/
		/*	------------------------------------------------------	*/

int GetNextSolution(int PS /* ProgramStatus */ )
{
	switch (PS) {
		case NORMAL_ITERATION:
		case BIFURCATION_DIAGRAM:
					return( IterateSolution() );
		case PLAYBACK:
					GetPlaybackSolution();
					return(FOUND_SOLUTION);
		case OPENING:
					return( GetOpenSolution() );
	}
}

Boolean StartNextSolution(int PS, Boolean *OKCont)
	/*	Iteration will be stopped here unless there's a problem	*/
{
	switch (PS) {
		case NORMAL_ITERATION:
		case BIFURCATION_DIAGRAM:
					SetHitNumber(++HitNumber);
					++CurHitNumber;
/*
					if (HitTime > 0.0)
*/
						if (!InitNextIteration()) {
							*OKCont = FALSE;
							if (PS == NORMAL_ITERATION)
								return(FALSE);
						}
/*
					if (PS == BIFURCATION_DIAGRAM)			return(GraphBD());
					else if (PS == BASINS_OF_ATTRACTION)	return(TRUE);
					else return(TRUE);
*/
					return(TRUE);
		case PLAYBACK:
					*OKCont = HitNumber >= 0;
					return( CheckNextPlayback() );
		case OPENING:
					*OKCont = HitNumber >= 0;
					return( CheckNextOpening() );
	}
}

Boolean OKtoGraph(int PS)
{
	switch (PS) {
		case NORMAL_ITERATION:		return(TRUE);
		case PLAYBACK:				return(TRUE);
		case OPENING:				return(TRUE);
/*
		case OPENING:				return(GraphWhileOpening);
		case OPENING:				return(GraphWhileOpening && (CurHitNumber != 0));
*/
		case BIFURCATION_DIAGRAM:	return(*pBDGraphInAllWindows);
	}
}
