/*	bbMenus.h
 *
 *	Menu constants for Bouncing Ball
 *
 *	-TA 7/21/90
 */

enum {								/*	Menu IDs	*/
		AppleMenuID = 1,
		FileMenuID,
		EditMenuID,
		ControlMenuID,
		ParametersMenuID,
		ViewMenuID,
		SpecialMenuID,
		SimpleSoundMenuID,
		WindowsMenuID,
		AdvancedSoundMenuID,
		SoundMenuID
};

enum {								/*	File menu options	*/
		NewItem = 1,
		OpenItem,
		SaveItem = OpenItem + 2,
		SaveAsItem,
		SaveDefaultsItem = SaveAsItem + 2,
		PageSetupItem = SaveDefaultsItem + 2,
		PrintItem,
		QuitItem = PrintItem + 2
};

enum {								/*	Edit menu options	*/
		UndoItem = 1,
		CutItem = UndoItem + 2,
		CopyItem,
		PasteItem,
		ClearItem,
		SuppressSaveItem = ClearItem + 2,
		AutoCommandKeyItem,
		BackgroundOperationItem = AutoCommandKeyItem + 2
};

enum {								/*	Control menu options	*/
		BeginIterationItem = 1,
		StopContinueItem,
		DoOneIterationItem,
		PlaybackItem = DoOneIterationItem + 2,
		InitialConditionsItem = PlaybackItem + 2,
		SystemParametersItem,
		GetInitFromLastItem = SystemParametersItem + 2,
		MaxIterationsItem = GetInitFromLastItem + 2,
		RunInBackgroundItem = MaxIterationsItem + 2
};

enum {								/*	View menu options	*/
		GraphRangeItem = 1,
		IterationSpeedItem,
		PSViewItem = IterationSpeedItem + 2,
		EPSViewItem,
		OrbitViewItem,
		ScrollOrbitItem = OrbitViewItem + 2,
		ClearIterationsItem = ScrollOrbitItem + 2,
		ShowAllIterationsItem,
		ClearIterLinesItem,
		ShowAllIterLinesItem,
		MagnifyPhaseSpaceItem = ShowAllIterLinesItem+2,
		MagnifyEmbeddedPSItem
};

enum {								/*	Special menu options	*/
		StartBifDiagItem = 1,
		StopContinueBifDiagItem,
		BifurcationDiagramItem,
		ClearBifDiagItem,
		GraphInAllWindowsBDItem,
		UseColorBDItem,
		ColorsItem = UseColorBDItem + 2
};

enum {								/*	Sound menu options	*/
		XnTonesItem = 1,	
		XnkTonesItem,
		AdvancedOptionsItem = XnkTonesItem + 2,
		MajorMode = AdvancedOptionsItem,	/* This and below used by bbSound as well	*/
		MinorMode,
		ChromaticMode,
		ContinuousMode,
		SimpleOptionsItem = ContinuousMode + 2
};

enum {								/*	Windows menu options	*/
/*
		EnlargeWindowItem = 1,
		ArrangeWindowsItem,
*/
		CloseWindowItem = 1,
		ArrangeWindowsItem,
		DefaultConfigItem,
		WindowSeparatorItem,
		TextWindowMenuItem = WindowSeparatorItem+2	/* this used bbWindows only */
};
