/*	qmPreferences.h
 *
 *	Data structure, macros for Quadratic Map preferences
 *
 *	-TA 6/26/91
 */

typedef struct {
								/*	Defaults	*/
		double				_DefaultX0;
		double				_DefaultLambda;
		Boolean				_DefaultBDGIAW;
		Boolean				_DefaultBDUseColor;

								/*	File menu	*/
		Boolean				_GraphWhileOpening;		/*	From BB; should never be used here	*/
		int					_DelimiterIndex;
								/*	Edit menu	*/
		Boolean				_SuppressSaveWarnings;
		Boolean				_AutoCommandKey;
		Boolean				_RunInBackground;
		Boolean				_FasterBackground;
		Boolean				_UseSoundInBackground;
								/*	Control menu	*/
		long				_MaxIterations;
								/*	View menu	*/
		double				_XMin, _XMax;
		Boolean				_UseAutoXMin, _UseAutoXMax;
		int					_RealIterationTime;
		int					_NLHeight;
		PhaseSpaceParams	_PSParams;
		int					_Embedding;
		EmbeddedPSParams	_EPSParams;
		int					_OrbitDotSize;
		int					_OrbitSpacing;
		Boolean				_ScrollOrbit;
								/*	Special menu	*/
		SolutionInfo		_csi;
								/*	Sound menu	*/
		Boolean				_XnTonesOn, _XnkTonesOn;
		int					_CurrentMode;

		long	Reserved1, Reserved2, Reserved3, Reserved4;

}	QMPreferences, **hQMPreferences;


#define	DefaultX0				((**hQMPrefs)._DefaultX0)
#define	DefaultLambda			((**hQMPrefs)._DefaultLambda)
#define	DefaultBDGIAW			((**hQMPrefs)._DefaultBDGIAW)
#define	DefaultBDUseColor		((**hQMPrefs)._DefaultBDUseColor)

#define	GraphWhileOpening		((**hQMPrefs)._GraphWhileOpening)
#define	DelimiterIndex			((**hQMPrefs)._DelimiterIndex)
#define	SuppressSaveWarnings	((**hQMPrefs)._SuppressSaveWarnings)
#define	AutoCommandKey			((**hQMPrefs)._AutoCommandKey)
#define	RunInBackground			((**hQMPrefs)._RunInBackground)
#define	FasterBackground		((**hQMPrefs)._FasterBackground)
#define	UseSoundInBackground	((**hQMPrefs)._UseSoundInBackground)
#define	MaxIterations			((**hQMPrefs)._MaxIterations)
#define	XMin					((**hQMPrefs)._XMin)
#define	XMax					((**hQMPrefs)._XMax)
#define	UseAutoXMin				((**hQMPrefs)._UseAutoXMin)
#define	UseAutoXMax				((**hQMPrefs)._UseAutoXMax)
#define	RealIterationTime		((**hQMPrefs)._RealIterationTime)
#define	NLHeight				((**hQMPrefs)._NLHeight)
#define	PSParams				((**hQMPrefs)._PSParams)
#define	Embedding				((**hQMPrefs)._Embedding)
#define	EPSParams				((**hQMPrefs)._EPSParams)
#define	OrbitDotSize			((**hQMPrefs)._OrbitDotSize)
#define	OrbitSpacing			((**hQMPrefs)._OrbitSpacing)
#define	ScrollOrbit				((**hQMPrefs)._ScrollOrbit)
#define	csi						((**hQMPrefs)._csi)
#define	XnTonesOn				((**hQMPrefs)._XnTonesOn)
#define	XnkTonesOn				((**hQMPrefs)._XnkTonesOn)
#define	CurrentMode				((**hQMPrefs)._CurrentMode)
