#include <stdio.h>
#include <math.h>

#include <MathUtils.h>
#include <StringUtils.h>
#include <GeneralUtils.h>
#include <GraphUtils.h>
#include <TextUtils.h>
#include "qm.h"
#include "qmPreferences.h"

/*	From qm.c	*/
	Boolean	CheckMem(Size ExtraMemory);
	Boolean	StartingMemCheck(void);
			GetIterationSpeed(void);
	Boolean	StartIterating(int New_PS);
			StopIterating(Boolean ContinueOK);
			BeginIfAppropriate(void);
	double	GetSolution(int HitNum);
	int		GetSolutionHit(int HitNum);
			ResetSolutions(void);
	Boolean	AddSolutionArray(void);
			AddSolution(double x_n);
			SetDefaultPrefs(void);
			SetDefaults(void);
			SaveDefaults(void);
			SetDefaultParams(void);
			DetermineIfColor(void);
			InitMultiFinderGlobals(void);
			_INIT(void);
			GetInitialFromLast(void);
	Boolean	GetInitialConditions(Boolean DefaultSame);
			SetValuesFromSystemParams(double oLambda);
	Boolean	GetSystemParameters(void);
			GetMaxIterations(void);
			AdvanceIterationStatus(void);
	Boolean	Handle_ITERATING(int PS);
			Handle_GRAPHING(int PS);
	Boolean	Handle_WRITING(int PS, Boolean *pOKCont);
	Boolean	Handle_META_ITERATING(int PS, Boolean *pOKCont, Boolean *pNeedToWait);
			HandleParamFiles(void);
			_MAIN(void);
			HandleContent(WindowPtr wp, Point pt, int mods);
			HandleMouseDown(EventRecord *pev);
			CheckVars_HandleUpdate(WindowPtr wp);
			HandleApp4Event(EventRecord *pEvent);
			_EVENT(EventRecord *theEvent);
	Boolean	NextEvent(int eventMask, EventRecord *theEvent);
			HandleAllActivates(void);
			HandleAllUpdates(void);
			HandleEvent(void);
			main(void);
			_HALT(void);

/*	From qmIteration.c	*/
			SetHitNumber(int NewHitNumber);
	Boolean	HandleSticking(int theEjection);
	Boolean	SetItoJ(Boolean NeedPhase);
			SetInitConditions(void);
	Boolean	InitNextIteration(void);
	Boolean	Initialize_Iteration_Globals(Boolean BeginningIteration);
	Boolean	Reset_Iteration_Globals(void);
	int		IterateSolution(void);
	Boolean	InitPlayback(void);
			GetPlaybackSolution(void);
	Boolean	CheckNextPlayback(void);
			StopOpeningFile(Boolean OpenOK);
	Boolean	GetFileParam(double *pf);
	int		GetFileHeader(void);
	Boolean	StartOpeningFile(void);
	Boolean	GetFloats(char *Line, int *pchn, double *px);
	Boolean	CheckForStuckOpen(void);
	int		GetOpenSolution(void);
	Boolean	FinishedOpening(void);
	Boolean	CheckNextOpening(void);
	int		GetNextSolution(int PS);
	Boolean	StartNextSolution(int PS, Boolean *OKCont);
	Boolean	OKtoGraph(int PS);

/*	From qmMenus.c	*/
			QuitPrematurely(void);
			InitQMMenus(Boolean UsingColor);
			AdjustQMMenus(void);
			ControlMenuStart(int PS);
			ControlMenuStop(int PS, Boolean OKToCont);
			HandleAppleMenu(int menuItem);
	Boolean	DoSave(void);
	Boolean	CheckOneSave(Boolean Quitting, int windex);
	Boolean	CheckNormalSaves(Boolean Quitting);
	Boolean	CheckAllSaves(Boolean Quitting);
			HandleFileMenu(int menuItem);
			HandleEditMenu(int menuItem);
			HandleControlMenu(int menuItem);
/*
			HandleParametersMenu(int menuItem);
*/
			HandleViewMenu(int menuItem);
			HandleSpecialMenu(int menuItem);
			SwitchSoundMenu(void);
			HandleSoundMenu(int menuItem);
			HandleWindowsMenu(int menuItem);
			_MENU(int menuID, int menuItem);
			HandleMenu(long theMenu);
			HandleKeyDown(long EventMessage, int Modifiers);

/*	From qmDialog.c	*/
			SelectBadField(DialogPtr dp, int index, Boolean *PreviousAllRight);
			BadParamAlert(char *s);
			AllBadValsAlert(char *s);
			FixBadValAlert(char *s);
			FixBadIntValAlert(char *s);
			ErrorAlert(char *s1, char *s2, char *s3, char *s4);
			ERROR(char *s);
			DoAboutQMDialog(void);
	Boolean	CheckInitCondDialog(DialogPtr dp, int itemNo);
	Boolean	DoInitCondDialog(double *nX0, Boolean *myClearSolutions,
				Boolean *RestartIteration);
	Boolean	CheckPhysSysDialog(DialogPtr dp, int itemNo);
	Boolean	DoPhysSysDialog(Boolean *RestartIteration);
			OutOfRangeAlert(char *s, long minL, long maxL);
	Boolean	myGetLongParamItem(DialogPtr dp, int itemNo, long *pl, char *s,
					long minL, long maxL);
	Boolean	CheckMaxIterationsDialog(DialogPtr dp, int itemNo);
	Boolean	DoMaxIterationsDialog(long *pMaxIterations);
	Boolean	GraphRangeDLogItemFilter(DialogPtr dp, int itemHit);
	Boolean	CheckGraphRangeDialog(DialogPtr dp, int itemNo);
	Boolean	DoGraphRangeDialog(double *pXMin, double *pXMax,
				double AutoXMin, double AutoXMax,
				Boolean *pUseAutoXMin, Boolean *pUseAutoXMax);
			StartOverflowMessage(Boolean positive);
			StopOverflowMessage(void);
	Boolean	IterSpeedDLogEventFilter(DialogPtr dp, EventRecord *pTheEvent,
			int *pItemHit, Boolean *pHowCKFShouldReturn);
	Boolean	DoIterationSpeedDialog(int *pMinPhaseInt);
	Boolean	MagPSDLogItemFilter(DialogPtr dp, int itemHit);
	Boolean	CheckMagnifyPhaseSpacesDialog(DialogPtr dp, int itemNo);
	Boolean	DoMagnifyPhaseSpacesDialog(DoubleRect *Actual, DoubleRect *Full,
				BooleanRect *UsesFull, Boolean IsPhaseSpace);
	Boolean	PhaseSpaceDialogFilter(DialogPtr dp, int itemNo);
	Boolean	CheckPhaseSpaceDialog(DialogPtr dp, int itemNo);
	Boolean	DoPhaseSpaceDialog(int *pNLHeight, PhaseSpaceParams *ppsi,
				Boolean *pShowAllIterLines);
	Boolean	CheckEmbeddedPSDialog(DialogPtr dp, int itemNo);
	Boolean	DoEmbeddedPSDialog(int *pEmbedding, EmbeddedPSParams *pepsi);
	Boolean	CheckOrbitDialog(DialogPtr dp, int itemNo);
	Boolean	DoOrbitDialog(int *pDotSize, int *pHorSpace);
	Boolean	DoShowWindowDialog(int windex);
			StartPrintingDialog(void);
	Boolean	HandlePrintingDialog(void);
			StopPrintingDialog(void);
	Boolean	DoQuitWarningDialog(Boolean *pWantsToSave, int windex);
	Boolean	DoSaveWarningDialog(Boolean *pWantsToSave, int windex);
	Boolean	DoBackgroundDialog(Boolean *pRunInBackground,
					Boolean *pRunQuickly, Boolean *pUseSoundInBG);
	pascal	int		MakeStdFileOutline(int item, DialogPtr StdFileDialog);
	pascal	int		DelimiterDLog(int itemNo, DialogPtr SaveAsDialog);
	Boolean	QMSaveAsDialog(char *prompt, int *vRef, char *fname);
	Boolean	QMSpecialSaveAsDialog(char *prompt, int *vRef, char *fname);
	Boolean	QMOpenDialog(OSType *OpenFileTypes, int NumOSTypes, int *vRef,
					char *fname, OSType *fType);

/*	From qmPhysics.c	*/
	double	QuadraticMap(double theLambda, double theX);
	double	nQuadMap(int n, double theLambda, double theX);

/*	From qmSound.c	*/
			InitSounds(void);
			FlipTonesOn(int SMenuItem);
			SetToneMode(int WhichMode);
	int 	GetTone(double thePhase);
			MakeTone(double thePhase, double prevPhase);

/*	From qmFiles.c	*/
			SetANilFileName(int theWindex);
			SetNilFileNames(void);
	char	*GetSaveFName(int windex);
			SetFileName(int theWindex);
	int		DecideWhichSaveWindow(void);
			InitQMFiles(void);
	int		GetNextParamFile(void);
	int		QMGetParamFiles(void);
	Boolean	QMGetFileLine(char *theLine);
	Boolean	CheckFirstLine(char *theLine);
			CloseOpenFile(void);
	Boolean	GetOpenWindows(void);
	Boolean	OpenFile(void);
			ResetDelimiter(void);
	Boolean	GetOpenFileName(int *pwindex);

/*	1.01 addition
 */
			SetOpenFileName(int windex);
/*	end, 1.01 addition
 */

			ResetFileName(void);
			GetTitleString(int theWindex, char *ts);
	Boolean	CloseSaveFile(Boolean NeedToDelete);
	Boolean	SaveCurWindows(void);
	Boolean	SaveFile(void);
			GetUntitledFileName(char *ps);
			SetGoodSaveFName(Boolean NewGoodSaveFName);
	Boolean	GetGoodSaveFName(void);
	Boolean	SaveAs(void);
	Boolean	SaveFileExists(void);
	Boolean	CreateDefaultsFile(void);
	Boolean	OpenDefaultsFile(void);
			CloseDefaultsFile(void);
	Boolean	OpenDefaults(Boolean *pGotPrefs);
	Boolean	SaveDefaultFile(void);
			HaltQMFiles(void);

/*	From qmPrint.c	*/
			myPrintIdleProc(void);
			InitPrinting(void);
			HaltPrinting(void);
			CheckPrintHandle(void);
			DoPageSetup(void);
			PrintHeader(int windex, int page);
			PrintTextWindow(int windex);
			PrintGraphicsWindow(int windex);
			PrintSpecialWindow(int windex);
			PrintFrontWindow(void);

/*	From qmGraphUtils.c	*/
			WriteVar(char *s, double f);
			DrawXn(char *s);
			InitFixedQMVars(double theLambda, double xScale, double yScale,
					DoubleRect *pgr, Boolean xGA0, Boolean yGA0);
	Fixed	QMFixed(Fixed l_fxd, Fixed x_fxd);
	int		FixedQM(int x, int n);
			DrawHAxis(Boolean ShowZero, double theXMin, double theXMax,
					Rect *pgr, Point Origin, double scale, double HashDist,
					int HashNum, Boolean ExactHashes, int Hash1Size, int Hash2Size,
					int fw, int spacing, int extra_spacing, int text_spacing,
					int axis_spacing);
			DrawVAxis(Boolean ShowZero, double theXMin, double theXMax,
					Rect *pgr, Point Origin, double scale, double HashDist,
					int HashNum, Boolean ExactHashes, int Hash1Size, int Hash2Size,
					int fw, int spacing, int extra_spacing, int text_spacing,
					int axis_spacing);
			LabelOrbitVAxis(double theXMin, double theXMax,
					Rect *pgr, Point Origin, int HAxisPos, double scale, double HashDist,
					int HashNum, int fw, int spacing, int extra_spacing,
					int text_spacing, int ods, Boolean DoZeroHash,
					RgnHandle GraphClipRgn);
	Boolean	LoadDashedPatterns(void);
	Boolean	TrackDashedRect(int h, int v, Rect *p_DragRect, Rect *p_Outline,
					Boolean ForMagnification);

/*	From qmText.c	*/
				SetTextPorts(GrafPtr gp1);
	int			GetTextIndex(int windex);
	int			GetWindexFromTindex(int tindex);
	QMTextPtr	GetTextFromTindex(int theTextIndex);
	TEHandle	GetQMTEHandle(int windex, int WhichText);
	Boolean		AnyTSText(void);
				ScrollText(TEHandle teh, int LinesToScroll);
				ScrollWindowText(int windex, int LinesToScroll);
				Scroll_If_Needed(void);
				ScrollBodyTE(void);
				SetNumLines(int windex);
				UpdateText(int windex, double theLambda);
				HandleTextActivation(int windex, int ActivateFlag);
				ActivateATextScroll(int windex);
				DeactivateATextScroll(int windex);
				ActivateTextScrolls(Boolean Activate_It);
				PtInBodyViewRect(int windex, Point pt);
				HandleTextSelection(int windex, Point pt, int mods);
				HandleTEXTCopy(int windex);
				InitHeaderTE(void);
				InitHeaderTEs(void);
				AppendVar(char *s, double d, TEHandle teh, int WholePlaces);
				AppendVarLn(char *s, double d, TEHandle teh, int WholePlaces);
				SetHeader(int windex, double Lambda);
				SetHeaders(double Lambda);
				ResetBodyOFs(void);
				InitBodyOFs(void);
				ClikLoopScroll(TEHandle teh, int LinesToScroll);
	pascal		Boolean	PasClikLoop(void);
				InitBodyTE(int windex);
				InitBodyTEs(void);
	Boolean		CheckBodyTESize(void);
	Boolean		CheckBodyTESizes(void);
	Boolean		WriteOutput(int hitnum, double x_n, int PS);
				NewTextEdit(void);
				InitQMTextEdit(double Lambda);
				DisposeTextEdit(int windex);
				HaltQMTextEdit(void);

/*	From qmControls.c	*/
			SetRScrollBarRect(WindowPtr wp, Rect *pr);
			SetBScrollBarRect(WindowPtr wp, Rect *pr);
			ResizeControl(ControlHandle ch, Rect *pr);
			ResetScrollBars(int i);
			CheckHiliteScrollBar(ControlHandle ch, Boolean ControlActive);
			QMHiliteControls(int i, Boolean ControlActive);
			HiliteTextScrollBar(int windex, Boolean Activate_It);
	int		GetTextScrollMax(int windex);
			SetTextScrollMax(int windex, int NumHiddenLines, Boolean SetValue);
			SetTextScrollPage(int windex, int LinesPerPage);
	int		GetTextScrollValue(int windex);
	int		TextScrollValueFromBottom(int windex);
	int		SetRelScrollVal(ControlHandle ch, int dhv);
			IncTextScrollValue(int windex, int LinesToScroll);
			ScrollWindowGraphics(int windex, int HScrollAmount,
					int VScrollAmount);
			ScrollWindow(int windex, int HScrollAmount, int VScrollAmount);
			ScrollWindowOneDirection(int windex, ControlHandle ch,
					int ScrollAmount);
	pascal	void	MyScrollBarAction(ControlHandle ch, int partCode);
			HandleScrollBar(int windex, ControlHandle ch, int partCode,
				Point pt);
	Boolean	HandleHotSpot(ControlHandle ch, Point pt);
	int		GetWhichHotSpot(int windex, ControlHandle ch);
	Boolean	HandleControl(int i, Point pt, int *pWhichHotSpot);
			ActivateAnimaHS(Boolean TurnOn, Rect *pBall, Rect *pTable);
	pascal	long	HotSpotControlDef(int varCode, ControlHandle ch,
				int message,long param);
			CreateHotSpots(int windex, int num);
			InitQMControls(void);

/*	From qmWindows.c	*/
	int		WindowIndex(WindowPtr wp);
	Boolean	WindowOpen(int windex);
	Boolean	IsMagnified(int windex);
	Size	WindowLocsSize(int n);
			WindowMoveTo(int i, int x, int y);
			WindowLineTo(int i, int x, int y);
			BackMoveTo(int i, int x, int y);
			BackLineTo(int i, int x, int y);
			BothMoveTo(int i, int x, int y);
			BothLineTo(int i, int x, int y);
	int		xFloatToCoord(int i, double f);
	int		yFloatToCoord(int i, double f);
	double	xCoordToFloat(int i, int Coord);
	double	yCoordToFloat(int i, int Coord);
	Fixed	xFloatToFixed(int i, double f);
	Fixed	yFloatToFixed(int i, double f);
			QMForceUpdate(WindowPtr wp);
			QMSizeWindow(WindowPtr wp, int h, int v);
			QMOpenWindow(WindowPtr wp);
			QMCloseWindow(WindowPtr wp);
	Boolean	QMCloseFrontWindow(void);
			QMCloseAllWindows(void);
			QMZoomWindow(Point Where, WindowPtr WhichWindow, int Part);
			MakeLargeWindow(WindowPtr wp);
			QMGrowWindow(Point pt, WindowPtr WhichWindow);
			QMDragWindow(Point pt, WindowPtr WhichWindow, int mods);
			QMGoAwayWindow(Point pt, WindowPtr WhichWindow);
			QMHandleActivate(WindowPtr wp, int ActivateFlag);
			SelectWindowIndex(int i);
			SetOpenWindows(void);
			DefaultWindowConfiguration(void);
	Boolean	GetDefaultWindowConfiguration(Boolean AtStartup);
			InitialWindowConfiguration(Boolean PrintingOnly);
			SetCurWindows(int windex);
			SetDefaultWindowConfiguration(void);
			AddWindowsToMenu(void);
			SetTextTitle(Boolean FileExists, int windex);
			GetTextTitle(char *theTitle);
	int		SelectOrderIndex(int i);
			ArrangeWindows(void);
			InitWindowArrangement(void);
			NewQMWindow(int windex);
			NewQMWindows(Boolean ClearSolutions);
	Boolean	InitQMOffPorts(void);
			InitQMWindows(void);
			HaltQMWindows(void);

/*	From qmImpactGraphics.c	*/
			SetPhaseSpacesStart(int theHitNumber);
			SetIterLinesStart(int theHitNumber, Boolean NeedRefresh);
			HandleIterLineMenus(void);
			GetOrbitInfo(void);
			SwitchScrollOrbit(void);
			ForceRefreshOrbit(void);
			SetOrbitOffset(int theHitNumber);
			SetWholeScreenOrbitCoords(void);
			SetOrbitCoords(void);
			DrawOrbitBackground(void);
			RefreshOrbit(void);
			InitOrbitGraphing(int yint);
			PlotInOrbit(int xint, int yint);
			GetPhaseSpaceInfo(void);
			InitFullPSRange(void);
			SetFullPSRange(void);
			GetPSMagnification(Boolean SkipDialog);
			CheckPSClick(Point pt, double *px0);
	Boolean	TrackPSRect(Point pt);
			InitPSScales(void);
	Boolean	UseIterLines(int myHN);
			PlotInPhaseSpace(double x_j, int myHN, int myCHN, Boolean Highlighting);
			RefreshPS(int myHitNumber);
			GetEmbeddedPSInfo(void);
			InitFullEPSRange(void);
			SetFullEPSRange(void);
			GetEPSMagnification(Boolean SkipDialog);
			CheckEPSClick(Point pt);
	Boolean	TrackEPSRect(Point pt);
			InitEPSScales(void);
			PlotInEmbeddedPS(double x_n, int myHN, int myCHN, Boolean Highlighting);
			RefreshEPS(int myHitNumber);
			SetAutoGraphRange(double theLambda, Boolean AtStartup);
			GetGraphRange(void);
			HandleLeftPSsHS(int windex);
			GraphFrom(int hitnum, int curhitnum, double x_n);
	Boolean	AddGraphicSolution(int hitnum, int curhitnum, double x_n, int PS);
			NewImpactGraphics(Boolean ClearSolutions);
			InitImpactGraphics(void);
			HaltImpactGraphics(void);

/*	From qmGraphics.c	*/
			StartWaiting(void);
			StopWaiting(void);
	int		FindQMClick(int i, Point pt);
			HandleUpdate(WindowPtr wp, int myHitNumber);
			MakePicture(int windex, GrafPtr gp, Rect *pDstRect);
			HandlePICTCopy(int windex);
			HandleCopy(int windex);
			NewGraphics(Boolean ClearSolutions, Boolean NeedToResetFileName);
	Boolean	InitGraphics(void);
			HaltGraphics(void);

/*	From qmBifDiag.c	*/
	double	GetBDOffsetPhase(double del);
	double	GetBDUnOffsetPhase(double del);
	int		GetDefaultInitIterTimes(double theDamping);
			CopyBDGraph(Rect *pr, int h, int v);
	Boolean	InitNextBD(void);
	Boolean	GetNextBD(void);
			StartBifurcationDiagram(void);
			ContinueBifurcationDiagram(void);
			GetBifDiagInfo(Boolean Magnifying);
	Boolean	TrackBDRect(Point pt);
	Boolean	InitBDScales(void);
			DrawCurrentBDBackground(void);
			DrawBDBackground(void);
			RefreshBD(void);
			PlotInBD(int yCoord);
	int		GetBDYPlot(double del, double vel);
			SetBDSolutionType(int SolType);
			CheckBDPeriodicity(void);
			GraphBD(void);
			ClearBifurcationDiagram(void);
	Boolean	SaveBDReturn(Boolean SaveOKSoFar);
	Boolean	SaveBDFile(void);
	Boolean	BadOpenBDReturn(void);
	Boolean	OpenBDFile(void);

/*	From qmSpecial.c	*/
				SeeIfStopSpecial(int windex);
	Boolean		SpecialGraphing(void);
	int			GetSpecialTimes(int theTimes, int DefaultTimes);
				SpecialMenuEnable(int windex, Boolean TurnOn, Boolean PauseOK);
				CheckGraphInAll(int windex);
				SwitchGraphInAll(int windex);
				CheckSpecialColor(int windex);
				SwitchInColor(int windex);
				SetSpecialTitle(Boolean FileExists, int windex);
				StringAddVar(char *s, double f, char *label,
						Boolean MorePrecision, Boolean ToPad);
				StringAddVarLn(char *s, double f, char *label,
						Boolean MorePrecision, Boolean ToPad);
	Boolean		CreateSpecialOffPort(GrafPtr *pgp, Rect *pr);
	Boolean		TestAdjacents(double y0, double y1, int per, int k);
	Boolean		TestPeriodicity(int per, Boolean *pWillBePeriodic,
						Boolean *pProbablyPeriodic);
	PicHandle	MakeSpecialPicture(GrafPtr gp);
	Boolean		SaveSpecialFile(int theWindex);
	Boolean		OpenSpecialFile(int theWindex);
				SetSpecialColor(int i, Boolean UseRGBValues);
				InitSpecialColors(void);
				GetSolutionColors(void);
				SetSpecialControls(int windex);
	Boolean		FindSpecialClick(int windex, Point pt);
				SetSpecialScrolling(int windex);
				ScrollCopyBackRect(int windex, Rect *pr, Boolean ToWindow);
				ScrollCopyBackToWindow(int windex);
				CopySpecialBackToPrint(int windex);
				NewSpecial(int windex);
				InitSpecial(void);

/*	From qmSpecialDialog.c	*/
	Boolean		DoSpecialWarningDialog(char *ps);
	Boolean		DoSpecialOpenContinueDialog(char *ps);
	Boolean		DoSpecialCloseStopDialog(char *ps);
	Boolean		DoSpecialClearDialog(char *ps);
	Boolean		ReplaceSolutionInfoDialog(char *ColOrPat, char *SpecialType);
				DoGraphInAllAlert(int windex);
	Boolean		BifDiagDLogItemFilter(DialogPtr dp, int itemHit);
	Boolean		CheckBifurcationDiagramDialog(DialogPtr dp, int itemNo);
	Boolean		DoBifurcationDiagramDialog(Boolean *StartIt);
	pascal		void	DrawSolColsRoutine(WindowPtr wp, int itemNo);
	Boolean		SolutionItemFilterProc(DialogPtr dp, int itemHit);
	DialogPtr	GetSolutionInfoDialog(void);
	Boolean		DoSolutionInfoDialog(void);
