#include <SoundDvr.h>
#include <SoundUtils.h>
#include <MusicUtils.h>
#include "qmPrototypes.h"
#include "qmMenus.h"

#define	BaseTone		512
#define	StdTime			5		/* in ticks--1/60ths of a second */
#define	Synchronous		-1L
#define Asynchronous	0L

						/*	From qm.c	*/
extern	hQMPreferences		hQMPrefs;
						/*	From qmMenus.c	*/
extern	MenuHandle	SimpleSoundMenuH, AdvancedSoundMenuH, SoundMenuH;

unsigned char		SoundSineWave[256];

InitSounds()
{
/*
	XnTonesOn = TRUE;
	XnkTonesOn = FALSE;
	CurrentMode = ContinuousMode;
*/

	MakeSoundSine((unsigned char *) &SoundSineWave);

	InitOctave(BaseTone);
}

FlipTonesOn(int SMenuItem)
{
	switch (SMenuItem) {
		case XnTonesItem:	{
			XnTonesOn = !XnTonesOn;
			CheckItem(SoundMenuH, SMenuItem, XnTonesOn);
/*
			CheckItem(SimpleSoundMenuH, SMenuItem, XnTonesOn);
			CheckItem(AdvancedSoundMenuH, SMenuItem, XnTonesOn);
*/
			break;
		}
		case XnkTonesItem:	{
			XnkTonesOn = !XnkTonesOn;
			CheckItem(SoundMenuH, SMenuItem, XnkTonesOn);
/*
			CheckItem(SimpleSoundMenuH, SMenuItem, XnkTonesOn);
			CheckItem(AdvancedSoundMenuH, SMenuItem, XnkTonesOn);
*/
			break;
		}
	}
}

SetToneMode(int WhichMode)
{
	CheckItem(SoundMenuH, CurrentMode, FALSE);
	CurrentMode = WhichMode;
	CheckItem(SoundMenuH, CurrentMode, TRUE);
}

int GetTone(thePhase)
	double	thePhase;
{
	int		theTone;

	switch (CurrentMode) {
		case MajorMode:
				theTone = GetMajorTone(thePhase);					break;
		case MinorMode:
				theTone = GetMinorTone(thePhase);					break;
		case ChromaticMode:
				theTone = GetChromaticTone(thePhase);				break;
		case ContinuousMode:
				theTone = GetContinuousLogTone(BaseTone, thePhase);	break;
	}

	theTone /= 2;

	return(theTone);
}

MakeTone(double thePhase, double prevPhase)
		/*	thePhase is between 0 and 1;
		 *	tone returned by GetTone will be between BaseTone/2 and
		 *	BaseTone Hz
		 */
{
	int		freq1, freq2;

	if (!( XnTonesOn || XnkTonesOn )) return;

	freq1 = (XnTonesOn) ? GetTone((thePhase-XMin)/(XMax-XMin)) : 0;
	freq2 = (XnkTonesOn && (prevPhase != NO_TONE)) ?
			GetTone((prevPhase-XMin)/(XMax-XMin)) : 0;

/*
	Note(freq1, StdAmplitude, StdTime, Synchronous);
*/
	if ( (freq1 != 0) || (freq2 != 0) )
		FourTone(StdTime, freq1, freq2, 0, 0,
				CP(SoundSineWave), (char *) Synchronous);
}