/*	bbSpecial.h
 *
 *	Include file for Bouncing Ball's "special" capabilities,
 *	Bifurcation Diagram and Basins of Attraction.
 *
 *		-TA 2/12/91
 */

#include <color.h>
#include <ColorToolbox.h>

#define	FirstBDPicture		2101

#define	MIN_StepSize		1
#define	MAX_StepSize		8
#define	DEFAULT_StepSize	(MIN_StepSize)

#define	BaseInitIterTimes	50
#define	AddedInitIterTimes	50		/*	Default = Base * damp + Added	*/
#define	AutoTimes			-1
#define	MinAutoShow			20
#define	AutoShowMultiplier	3
#define	DiffSolutionInc		16
#define	MaxCIITimesIncs		30
#define	MinProbableCount	10

#define	BD_Spaces			"\P   "

#define	SpecialFieldWidth	10
#define	SpecialPrecision	(SpecialFieldWidth-1)

#define BD_BottomMargin		(ScrollBarWidth + 3*StdMargin + 3*TextLineHeight + 2*TextHeight - 2)
#define	BD_MinSize			16

#define	MinSpecialLabelSeparation	3

#define	BETWEEN(b,a,c)		( ((b)-(a)) * ((b)-(c)) <= 0 )
/*	a must be less than c
((b)>=(a)) && ((b)<=(c)) )
*/

#define	BlackColorIndex			0

/*
typedef struct {
			double			x_i;	(*	Same as in Solutions...	*)
		}	ImpactSet;
*/

typedef struct {
			IterationVars	Vars;
			GrafPtr			Graph;
			int				CurrentXInt, MaxXInt;
			DoubleRect		GraphRange;
			double			x00;
			int				InitIterTimes;
			int				ShowTimes;
			Boolean			GraphInAllWindows, FullWindow, InColor;
			Rect			WindowSize;
								/*	Init. cond. at each x-value	*/
			double			**InitConds;
								/*	Solution types--first CurrentXInt, type	*/
			int				MaxDiffSolutions, DiffSolutions;
			Point			**SolutionTypes;	/* h CurrentXInt, v type */
			Rect			HS0_Rect, HS1_Rect;
			Rect			LocalGR;
			long			Reserved1, Reserved2, Reserved3, Reserved4;
		}	BifDiagRecord, *pBifDiagRecord;
